VERSION 5.00
Begin VB.UserControl asRuler 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000018&
   CanGetFocus     =   0   'False
   ClientHeight    =   1095
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ControlContainer=   -1  'True
   ScaleHeight     =   1095
   ScaleWidth      =   4800
   ToolboxBitmap   =   "ctlRuler.ctx":0000
   Begin VB.Menu mnuMenu 
      Caption         =   "Kontext"
      Visible         =   0   'False
      Begin VB.Menu mnuMode 
         Caption         =   "Centimeter"
         Index           =   0
      End
      Begin VB.Menu mnuMode 
         Caption         =   "Inch"
         Index           =   1
      End
      Begin VB.Menu mnuMode 
         Caption         =   "Pixel * 100"
         Index           =   2
      End
      Begin VB.Menu mnuMode 
         Caption         =   "Twip * 1000"
         Index           =   3
      End
   End
End
Attribute VB_Name = "asRuler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
(ByVal hwnd As Long, ByVal nIndex As Long) As Long

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
(ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Declare Function SetWindowPos Lib "user32" _
(ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, _
ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Declare Function GetSysColor Lib "USER32.DLL" (ByVal nIndex As Long) As Long

Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOOWNERZORDER = &H200
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4

Private x1 As Single
Private RScale As Long

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Enum RulerModeConst
    Millimeters = 0
    Inch = 1
    Pixel = 2
    Twips = 3
End Enum
Public Enum asrOrientationConstants
    asrHorizontal = 0
    asrVertival = 1
End Enum
Public Enum eBorderStyle
    [Kein] = 0
    [Fest Einfach] = 1
    [erhht] = 2
    [Rahmen] = 3
End Enum
Private m_Mode As RulerModeConst
Private m_Orientation As asrOrientationConstants

'Ereignisdeklarationen:
Event ChangeRulerMode()
Event Resize() 'MappingInfo=UserControl,UserControl,-1,Resize
'Standard-Eigenschaftswerte:
Const m_def_BackColor2 = &H80000018
Const m_def_BackgroundGradient = False
Const m_def_Distance = 0
Const m_def_BorderStyle = 0
Const m_def_ScaleColor = &H80000012
Const m_def_ForeColor = &H80000012
Const m_def_BackColor = &H80000018
'Eigenschaftsvariablen:
Dim m_BackColor2 As OLE_COLOR
Dim m_BackgroundGradient As Boolean
Dim m_Distance As Byte
Dim m_BorderStyle As eBorderStyle
Dim m_ScaleColor As OLE_COLOR
Dim m_ForeColor As OLE_COLOR
Dim m_BackColor As OLE_COLOR

Public Property Get RulerMode() As RulerModeConst
    RulerMode = m_Mode
End Property

Public Property Let RulerMode(New_Mode As RulerModeConst)
    m_Mode = New_Mode
    Select Case m_Mode
        Case 0
            RScale = 570
        Case 1
            RScale = 1440
        Case 2
            RScale = Screen.TwipsPerPixelX * 100
        Case 3
            RScale = 1000
    End Select
    UserControl.Cls
    Call DrawRuler
    
    RaiseEvent ChangeRulerMode
    PropertyChanged "RulerMode"
End Property

Public Property Get Orientation() As asrOrientationConstants
    Orientation = m_Orientation
End Property

Public Property Let Orientation(New_Val As asrOrientationConstants)
    m_Orientation = New_Val
    UserControl.Cls
    Call DrawRuler
    PropertyChanged "Orientation"
End Property

Private Sub BorderStyleRaised(ByVal hwnd As Long, Optional ByVal Undo As Boolean)
    Dim nStyle As Long
    
    Const GWL_STYLE = (-16)
    Const WS_DLGFRAME = &H400000
    
    nStyle = GetWindowLong(hwnd, GWL_STYLE)
    If Undo Then
        nStyle = nStyle And Not WS_DLGFRAME
    Else
        nStyle = nStyle Or WS_DLGFRAME
    End If
    SetWindowLong hwnd, GWL_STYLE, nStyle
    SetWindowPos hwnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER Or SWP_NOZORDER Or SWP_FRAMECHANGED
End Sub

Private Sub DrawRuler()
    Dim Sincr As Single
    'Scalemode is in TWIPS 1440 per inch
    Dim I As Integer
    'Number of segment across form
    Sincr = RScale / 10
    With UserControl
        .BackColor = m_BackColor
        Dim RulerGradient As Gradient
        Set RulerGradient = New Gradient
        Dim r As RECT

        If m_Orientation = asrHorizontal Then
            '**********************************************************
            If m_BackgroundGradient Then
                        r.Left = 0
                        r.Top = 0
                        r.Right = UserControl.ScaleWidth '/ 3
                        r.Bottom = UserControl.ScaleHeight / 15
                    Call RulerGradient.DrawGradient(UserControl.hDC, VarPtr(r), m_BackColor2, m_BackColor, GD_VERICALLY)
            End If
            '**********************************************************
        
            Do While Sincr < .ScaleWidth
                'Number of sections
                For I = 1 To 10
                    'Size of Tics
                    .ForeColor = m_ScaleColor
                    If I = 10 Then
                        UserControl.Line (Sincr, 0)-(Sincr, .ScaleHeight)
                        .CurrentY = m_Distance
                        .ForeColor = m_ForeColor
                        UserControl.Print CStr(Int(Sincr / RScale))
                    ElseIf I = Int(10 * 0.5) Then
                        UserControl.Line (Sincr, .ScaleHeight - _
                        (.ScaleHeight * 0.5))-(Sincr, .ScaleHeight)
                    Else
                        UserControl.Line (Sincr, .ScaleHeight - _
                        (.ScaleHeight * 0.25))-(Sincr, .ScaleHeight)
                    End If
                    Sincr = Sincr + (RScale / 10)
                Next
            Loop
        Else
            '**********************************************************
            If m_BackgroundGradient Then
                        r.Left = 0
                        r.Top = 0
                        r.Right = UserControl.ScaleWidth / 15
                        r.Bottom = UserControl.ScaleHeight '/ 20
                    Call RulerGradient.DrawGradient(UserControl.hDC, VarPtr(r), m_BackColor, m_BackColor2, GD_HORIZONTALLY)
            End If
            '**********************************************************
            Do While Sincr < .ScaleHeight
                'Number of sections
                For I = 1 To 10
                    'Size of Tics
                    .ForeColor = m_ScaleColor
                    If I = 10 Then
                        'Einheiten schreiben
                        UserControl.Line (0, Sincr)-(.ScaleHeight, Sincr)
                        .CurrentX = m_Distance
                        .ForeColor = m_ForeColor
                        UserControl.Print CStr(Int(Sincr / RScale))
                    ElseIf I = Int(10 * 0.5) Then
                        '50%
                        UserControl.Line (.ScaleWidth - _
                        (.ScaleWidth * 0.5), Sincr)-(.ScaleWidth, Sincr)
                    Else
                        UserControl.Line (.ScaleWidth - _
                        (.ScaleWidth * 0.25), Sincr)-(.ScaleWidth, Sincr)
                    End If
                    Sincr = Sincr + (RScale / 10)
                Next
            Loop
        End If
    End With
End Sub

Public Sub MouseMoved(X As Single)
    With UserControl
        .DrawMode = 6
        If m_Orientation = asrHorizontal Then
            UserControl.Line (X, 0)-(X, .ScaleHeight)
            If x1 > 0 Then
                UserControl.Line (x1, 0)-(x1, .ScaleHeight)
            End If
            x1 = X
        Else
            UserControl.Line (0, X)-(.ScaleWidth, X)
            If x1 > 0 Then
                UserControl.Line (0, x1)-(.ScaleWidth, x1)
            End If
            x1 = X
        End If
        .DrawMode = 13
    End With
End Sub

Private Sub mnuMenu_Click()
    Dim I As Integer
    For I = 0 To mnuMode.Count - 1
        mnuMode(I).Checked = False
    Next I
    mnuMode(m_Mode).Checked = True
End Sub

Private Sub mnuMode_Click(Index As Integer)
    RulerMode = Index
End Sub

Private Sub UserControl_Initialize()
    RScale = 570
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 2 Then UserControl.PopupMenu mnuMenu
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        m_Orientation = .ReadProperty("Orientation", 0)
        RulerMode = .ReadProperty("RulerMode", 0)
        m_BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
        UserControl.BackColor = m_BackColor
        Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
        m_ForeColor = .ReadProperty("ForeColor", m_def_ForeColor)
        m_ScaleColor = .ReadProperty("ScaleColor", m_def_ScaleColor)
        m_BorderStyle = .ReadProperty("BorderStyle", m_def_BorderStyle)
        m_Distance = .ReadProperty("Distance", m_def_Distance)
        m_BackgroundGradient = .ReadProperty("BackgroundGradient", m_def_BackgroundGradient)
        m_BackColor2 = .ReadProperty("BackColor2", m_def_BackColor2)
    End With
    
    Select Case m_BorderStyle
        Case 0
            BorderStyleRaised UserControl.hwnd, True
            UserControl.BorderStyle = m_BorderStyle
        Case 1
            BorderStyleRaised UserControl.hwnd, True
            UserControl.BorderStyle = m_BorderStyle
        Case 2
            UserControl.BorderStyle = 0
            BorderStyleRaised UserControl.hwnd, False
        Case 3
            UserControl.BorderStyle = 1
            BorderStyleRaised UserControl.hwnd, False
    End Select
    
End Sub

Private Sub UserControl_Resize()
    RaiseEvent Resize
    UserControl.Cls
    x1 = 0
    'Draw Ruler 16ths of an inch
    DrawRuler

End Sub

'Private Sub UserControl_Show()
''    DrawRuler
'
'End Sub
'
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
On Error GoTo Fehlerbehandlung

    With PropBag
        .WriteProperty "Orientation", m_Orientation, 0
        .WriteProperty "RulerMode", m_Mode, 0
        .WriteProperty "Font", UserControl.Font, Ambient.Font
        .WriteProperty "BackColor", m_BackColor, m_def_BackColor
        .WriteProperty "ForeColor", m_ForeColor, m_def_ForeColor
        .WriteProperty "ScaleColor", m_ScaleColor, m_def_ScaleColor
        .WriteProperty "BorderStyle", m_BorderStyle, m_def_BorderStyle
        .WriteProperty "Distance", m_Distance, m_def_Distance
        .WriteProperty "BackgroundGradient", m_BackgroundGradient, m_def_BackgroundGradient
        .WriteProperty "BackColor2", m_BackColor2, m_def_BackColor2
    End With

Exit Sub
Fehlerbehandlung:
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Gibt ein Font-Objekt zurck."
Attribute Font.VB_UserMemId = -512
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set UserControl.Font = New_Font
    UserControl.Cls
    DrawRuler
    PropertyChanged "Font"
End Property

'Eigenschaften fr Benutzersteuerelement initialisieren
Private Sub UserControl_InitProperties()
    Set UserControl.Font = Ambient.Font
    m_BackColor = m_def_BackColor
    m_ForeColor = m_def_ForeColor
    m_ScaleColor = m_def_ScaleColor
    m_BorderStyle = m_def_BorderStyle
    m_Distance = m_def_Distance
    m_BackgroundGradient = m_def_BackgroundGradient
    m_BackColor2 = m_def_BackColor2
End Sub

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbyellow
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "gibt die Hintergrundfarbe zurck oder legt sie fest"
    BackColor = m_BackColor
    
    'Umwandlen einer Systemfarbe nach RGB
    If (m_BackColor And &HFF000000) = &H80000000 Then _
    m_BackColor = GetSysColor(m_BackColor And &HFFFFFF)

End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    m_BackColor = New_BackColor
    
    'Umwandlen einer Systemfarbe nach RGB
    If (m_BackColor And &HFF000000) = &H80000000 Then _
    m_BackColor = GetSysColor(m_BackColor And &HFFFFFF)

    Call DrawRuler
    PropertyChanged "BackColor"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbblack
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "gibt die Schriftfarbe zurck oder legt sie fest"
    ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    m_ForeColor = New_ForeColor
    Call DrawRuler
    PropertyChanged "ForeColor"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbblack
Public Property Get ScaleColor() As OLE_COLOR
Attribute ScaleColor.VB_Description = "gibt die Farbe der Skalierung zurck oder legt sie fest"
    ScaleColor = m_ScaleColor
End Property

Public Property Let ScaleColor(ByVal New_ScaleColor As OLE_COLOR)
    m_ScaleColor = New_ScaleColor
    Call DrawRuler
    PropertyChanged "ScaleColor"
End Property

Public Property Get BorderStyle() As eBorderStyle
Attribute BorderStyle.VB_Description = "Gibt den Rahmenstil fr ein Objekt zurck oder legt diesen fest."
    BorderStyle = m_BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As eBorderStyle)
    m_BorderStyle = New_BorderStyle
    
    Select Case m_BorderStyle
        Case 0
            BorderStyleRaised UserControl.hwnd, True
            UserControl.BorderStyle = m_BorderStyle
        Case 1
            BorderStyleRaised UserControl.hwnd, True
            UserControl.BorderStyle = m_BorderStyle
        Case 2
            UserControl.BorderStyle = 0
            BorderStyleRaised UserControl.hwnd, False
        Case 3
            UserControl.BorderStyle = 1
            BorderStyleRaised UserControl.hwnd, False
    End Select

    UserControl.Cls
    Call DrawRuler
    
    PropertyChanged "BorderStyle"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=1,0,0,0
Public Property Get Distance() As Byte
Attribute Distance.VB_Description = "gibt die Schriftdistanz zum Rand zurck oder legt sie fest"
    Distance = m_Distance
End Property

Public Property Let Distance(ByVal New_Distance As Byte)
    m_Distance = New_Distance

    UserControl.Cls
    Call DrawRuler
    
    PropertyChanged "Distance"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=0,0,0,False
Public Property Get BackgroundGradient() As Boolean
Attribute BackgroundGradient.VB_Description = "legt fest ob ein Gradientverlauf angezeigt werden soll"
    BackgroundGradient = m_BackgroundGradient
End Property

Public Property Let BackgroundGradient(ByVal New_BackgroundGradient As Boolean)
    m_BackgroundGradient = New_BackgroundGradient

    UserControl.Cls
    Call DrawRuler
    
    PropertyChanged "BackgroundGradient"
End Property

'ACHTUNG! DIE FOLGENDEN KOMMENTIERTEN ZEILEN NICHT ENTFERNEN ODER VERNDERN!
'MemberInfo=10,0,0,vbblue
Public Property Get BackColor2() As OLE_COLOR
Attribute BackColor2.VB_Description = "gibt die Hintergrundfarbe zurck oder legt sie fest"
    BackColor2 = m_BackColor2
    
    'Umwandlen einer Systemfarbe nach RGB
    If (m_BackColor2 And &HFF000000) = &H80000000 Then _
    m_BackColor2 = GetSysColor(m_BackColor2 And &HFFFFFF)
    
End Property

Public Property Let BackColor2(ByVal New_BackColor2 As OLE_COLOR)
    m_BackColor2 = New_BackColor2
    
    'Umwandlen einer Systemfarbe nach RGB
    If (m_BackColor2 And &HFF000000) = &H80000000 Then _
    m_BackColor2 = GetSysColor(m_BackColor2 And &HFFFFFF)

    UserControl.Cls
    Call DrawRuler
    
    PropertyChanged "BackColor2"
End Property

