VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsEncryption"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Autor: Tim Braun
'E-Mail: zork@tipsntricks.de
Private Declare Function CryptAcquireContext Lib "advapi32.dll" Alias "CryptAcquireContextA" (ByRef phProv As Long, ByVal pszContainer As String, ByVal pszProvider As String, ByVal dwProvType As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptCreateHash Lib "advapi32.dll" (ByVal hProv As Long, ByVal Algid As Long, ByVal hSessionKey As Long, ByVal dwFlags As Long, ByRef phHash As Long) As Long
Private Declare Function CryptHashData Lib "advapi32.dll" (ByVal hHash As Long, ByVal pbData As String, ByVal dwDataLen As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptDeriveKey Lib "advapi32.dll" (ByVal hProv As Long, ByVal Algid As Long, ByVal hBaseData As Long, ByVal dwFlags As Long, ByRef hSessionKey As Long) As Long
Private Declare Function CryptDestroyHash Lib "advapi32.dll" (ByVal hHash As Long) As Long
Private Declare Function CryptEncrypt Lib "advapi32.dll" (ByVal hSessionKey As Long, ByVal hHash As Long, ByVal Final As Long, ByVal dwFlags As Long, ByVal pbData As String, ByRef pdwDataLen As Long, ByVal dwBufLen As Long) As Long
Private Declare Function CryptDestroyKey Lib "advapi32.dll" (ByVal hSessionKey As Long) As Long
Private Declare Function CryptReleaseContext Lib "advapi32.dll" (ByVal hProv As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptDecrypt Lib "advapi32.dll" (ByVal hSessionKey As Long, ByVal hHash As Long, ByVal Final As Long, ByVal dwFlags As Long, ByVal pbData As String, ByRef pdwDataLen As Long) As Long
Private Declare Function CryptGetKeyParam Lib "advapi32.dll" (ByVal hSessionKey As Long, ByVal dwParam As Long, ByVal pbData As String, ByRef pdwDataLen As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptSetKeyParam Lib "advapi32.dll" (ByVal hSessionKey As Long, ByVal dwParam As Long, ByVal pbData As String, ByVal dwFlags As Long) As Long
Private Declare Function CryptGenRandom Lib "advapi32.dll" (ByVal hProv As Long, ByVal dwLen As Long, ByVal pbBuffer As String) As Long
Private Declare Function CryptGenKey Lib "advapi32.dll" (ByVal hProv As Long, ByVal Algid As Long, ByVal dwFlags As Long, ByRef hSessionKey As Long) As Long
Private Declare Function CryptGetHashParam Lib "advapi32.dll" (ByVal hHash As Long, ByVal dwParam As Long, ByVal pbData As String, ByRef pdwDataLen As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptSetHashParam Lib "advapi32.dll" (ByVal hHash As Long, ByVal dwParam As Long, ByVal pbData As String, ByVal dwFlags As Long) As Long
Private Declare Function CryptExportKey Lib "advapi32.dll" (ByVal hSessionKey As Long, ByVal hExpKey As Long, ByVal dwBlobType As Long, ByVal dwFlags As Long, ByVal pbData As String, ByRef pdwDataLen As Long) As Long
Private Declare Function CryptImportKey Lib "advapi32.dll" (ByVal hProv As Long, ByVal pbData As String, ByVal dwDataLen As Long, ByVal hPubKey As Long, ByVal dwFlags As Long, ByRef phKey As Long) As Long
Private Declare Function CryptGetUserKey Lib "advapi32.dll" (ByVal hProv As Long, ByVal dwKeySpec As Long, ByVal phUserKey As Long) As Long
Private Declare Function CryptSignHash Lib "advapi32.dll" Alias "CryptSignHashA" (ByVal hHash As Long, ByVal dwKeySpec As Long, ByVal sDescription As String, ByVal dwFlags As Long, ByVal pbSignature As String, pdwSigLen As Long) As Long
Private Declare Function CryptVerifySignature Lib "advapi32.dll" Alias "CryptVerifySignatureA" (ByVal hHash As Long, ByVal pbSignature As String, ByVal dwSigLen As Long, ByVal hPubKey As Long, ByVal sDescription As String, ByVal dwFlags As Long) As Long

Private Const SERVICE_PROVIDER As String = "Microsoft Base Cryptographic Provider v1.0" & vbNullChar
Private Const KEY_CONTAINER As String = "Tutorial API" & vbNullChar
Private Const PROV_RSA_FULL As Long = 1
Private Const CRYPT_NEWKEYSET As Long = 8
Private Const CRYPT_DELETEKEYSET As Long = 16
Private Const CRYPT_CREATE_SALT As Long = 4
Private Const CRYPT_EXPORTABLE As Long = 1
Private Const KP_SALT As Long = 2
Private Const ALG_CLASS_DATA_ENCRYPT As Long = 24576
Private Const ALG_CLASS_HASH As Long = 32768
Private Const ALG_TYPE_ANY As Long = 0
Private Const ALG_TYPE_STREAM As Long = 2048
Private Const ALG_SID_RC4 As Long = 1
Private Const ALG_SID_MD5 As Long = 3
Private Const ALG_SID_SHA As Long = 4
Private Const CALG_MD5 As Long = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_MD5)
Private Const CALG_RC4 As Long = ((ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_STREAM) Or ALG_SID_RC4)
Private Const CALG_SHA As Long = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_SHA)
Private Const AT_KEYEXCHANGE As Long = 1
Private Const AT_SIGNATURE As Long = 2
Private Const HP_HASHVAL As Long = 2
Private Const SIMPLEBLOB = 1
Private Const PUBLICKEYBLOB As Long = 6
Private Const PRIVATEKEYBLOB As Long = 7
Private Const CRYPT_NO_SALT = 16
Private Const NTE_BAD_SIGNATURE As Long = -2146893818


Dim hCryptProv As Long
Dim strSALT As String
Dim strHash As String
Dim hSessionKey As Long
Dim hKeyPair As Long
Dim strPublicPrivateBlob As String
Dim strPublicBlob As String
Dim strSessionBlob As String
Dim lngType As Long
Dim strSig As String

Public Function StartSession()
    Dim lngReturnValue As Long

    lngReturnValue = CryptAcquireContext(hCryptProv, KEY_CONTAINER, SERVICE_PROVIDER, PROV_RSA_FULL, CRYPT_NEWKEYSET) ' Handle erstellen
    If lngReturnValue = 0 Then
        lngReturnValue = CryptAcquireContext(hCryptProv, KEY_CONTAINER, SERVICE_PROVIDER, PROV_RSA_FULL, 0) ' Versuchen ein bereits erstelltes Handle zu nutzen, wenn nicht dann...
        If lngReturnValue = 0 Then Err.Raise Err.LastDllError, , "DLL gab Fehler zurck.  Fehler." & vbCrLf & "Fehler Beim erstellen des Handles"
    End If
End Function

Public Function EndSession()
    If hSessionKey <> 0 Then CryptDestroyKey hSessionKey ' Key der Session zerstren

    If hCryptProv <> 0 Then CryptReleaseContext hCryptProv, 0
End Function

Public Function EnDeCrypt(ByVal Text As String, ByVal Key As String, Encrypt As Boolean)
    Dim lngLength As Long
    Dim lngSALTLen As Long
    Dim lngReturnValue As Long
    
    KeyFromPW Key 'Passwort in Key umwandeln
    If Encrypt Then
        lngReturnValue = CryptGetKeyParam(hSessionKey, KP_SALT, vbNull, lngSALTLen, 0) 'String mit Verschlsselungsspezifikationen
    
        strSALT = String(lngSALTLen + 1, vbNullChar)
        lngReturnValue = CryptGenRandom(hCryptProv, lngSALTLen, strSALT)
    
    
        If lngReturnValue = 0 Then Err.Raise Err.LastDllError, , "Dll gab Fehler aus. SALT konnte nicht berechnet werden!"
    
    End If

    lngReturnValue = CryptSetKeyParam(hSessionKey, KP_SALT, strSALT, 0) ' strSALT setzen
    If lngReturnValue = 0 Then Err.Raise Err.LastDllError, , "DLL-Fehelr: Konnte SALT nicht setzen."

    lngLength = Len(Text)
    If Encrypt Then 'Verschlsseln
        lngReturnValue = CryptEncrypt(hSessionKey, 0, 1, 0, Text, lngLength, lngLength)
        If lngReturnValue = 0 Then Err.Raise Err.LastDllError, , "Fehler whrend des Encrypt-Vorgangs."
    Else 'Entschlsseln
        lngReturnValue = CryptDecrypt(hSessionKey, 0, 1, 0, Text, lngLength)
        If lngReturnValue = 0 Then Err.Raise Err.LastDllError, , "Fehler whrend des Decrypt-Vorgangs."
    End If


    EnDeCrypt = Left$(Text, lngLength)


    If hSessionKey <> 0 Then CryptDestroyKey hSessionKey 'Key zerstren
End Function

Private Sub KeyFromPW(ByVal Key As String)

    Dim lngParams As Long
    Dim lngReturnValue As Long
    Dim strHash As String
    Dim lngHashLen As Long
    Dim hHash As Long


    lngReturnValue = CryptCreateHash(hCryptProv, CALG_SHA, 0, 0, hHash) 'Hash erstellen
    If lngReturnValue = 0 Then Err.Raise Err.LastDllError, , "DLL gab Error aus. Hash-Objekt kann nicht erstellt werden! (CryptCreateHash API)"



    lngReturnValue = CryptHashData(hHash, Key, Len(Key), 0) 'Key in den Hash schreiben
    If lngReturnValue = 0 Then Err.Raise Err.LastDllError, , "DLL-Fehler: Daten konnten nicht in den Hash geschrieben werden (CryptHashData API)"

    lngReturnValue = CryptGetHashParam(hHash, HP_HASHVAL, vbNull, lngHashLen, 0) 'Lnge des Hash ermitteln
    strHash = String(lngHashLen + 1, vbNullChar) 'String auf ermittelte Lnge setzen
    lngReturnValue = CryptGetHashParam(hHash, HP_HASHVAL, strHash, lngHashLen, 0) 'Key auslesen
    If lngReturnValue = 0 Then Err.Raise Err.LastDllError, , "DLL gab Fehler aus. Hash-Value ungltig!"


    lngParams = CRYPT_EXPORTABLE

    If hSessionKey <> 0 Then CryptDestroyKey hSessionKey


    lngReturnValue = CryptDeriveKey(hCryptProv, CALG_RC4, hHash, lngParams, hSessionKey)
    If lngReturnValue = 0 Then Err.Raise Err.LastDllError, , "Schon wieder DLL-Fehler. Sessionkey konnte nicht errechnet werden ;-(!  (CryptDeriveKey API)"


    If hHash <> 0 Then CryptDestroyHash hHash 'Hash zerstren

End Sub

Public Function EncryptString(ByVal Text As String, ByVal Password As String) As String

    EncryptString = EnDeCrypt(Text, Password, True)

End Function

Public Function DecryptString(ByVal Text As String, ByVal Password As String) As String

    DecryptString = EnDeCrypt(Text, Password, False)

End Function


