Attribute VB_Name = "mdlBackColor"
Option Explicit

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

' Der Source stammt ursprnglich von David Cannings und wurde auf
' http://edeca.net/site/code:rtbhighlight
' verffentlicht

' Win32 API Deklarationen
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
    (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal _
    lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long

' Konstanten:
Private Const LF_FACESIZE = 32
Private Const SCF_SELECTION = 1
Private Const CFM_BACKCOLOR = &H4000000
Private Const CFE_AUTOBACKCOLOR = CFM_BACKCOLOR
Private Const WM_USER = &H400
Private Const EM_SETCHARFORMAT = (WM_USER + 68)
Private Const EM_GETCHARFORMAT = (WM_USER + 58)

' CharFormat Struktur, die mittels SendMessage an das Control bergeben wird:
Private Type CHARFORMAT2
    cbSize As Integer
    wPad1 As Integer
    dwMask As Long
    dwEffects As Long
    yHeight As Long
    yOffset As Long
    crTextColor As Long
    bCharSet As Byte
    bPitchAndFamily As Byte
    szFaceName(0 To LF_FACESIZE - 1) As Byte
    wPad2 As Integer
    wWeight As Integer
    sSpacing As Integer
    crBackColor As Long
    lLCID As Long
    dwReserved As Long
    sStyle As Integer
    wKerning As Integer
    bUnderlineType As Byte
    bAnimation As Byte
    bRevAuthor As Byte
    bReserved1 As Byte
End Type


Public Function GetSelBackColor(ByVal RTFhwnd As Long) As OLE_COLOR
    ' ermitteln der Hintergrundfarbe des selektierten Bereichs der RichTextBox
    Dim udtChar As CHARFORMAT2

    ' initialisieren der CharFormat Struktur:
    udtChar.cbSize = LenB(udtChar)
    
    ' ber den dwMask Member der Struktur wird bestimmt welche Informationen
    ' in die Struktur bertragen werden sollen:
    udtChar.dwMask = CFM_BACKCOLOR  'wir wollen die Back Color
    
    ' Nun schicken wir dem Control eine EM_GETCHARFORMAT Message, und
    ' bekommen im crBackColor Member des udtChar die Farbe zurck:
    SendMessage RTFhwnd, EM_GETCHARFORMAT, SCF_SELECTION, udtChar

    GetSelBackColor = udtChar.crBackColor
End Function

Public Function SetSelBackColor(ByVal RTFhwnd As Long, _
    ByVal NewSelFontBackColor As OLE_COLOR)
    
    ' setzen der Hintergrundfarbe des selektierten Bereichs der RichTextBox
    Dim udtChar As CHARFORMAT2
    
    ' initialisieren der CharFormat Struktur:
    udtChar.cbSize = LenB(udtChar)
    
    ' ber den dwMask Member der Struktur wird bestimmt welche Informationen
    ' aus der Struktur bernommen werden sollen:
    udtChar.dwMask = CFM_BACKCOLOR  'wir wollen die Back Color

    ' wurde als NewSelFontBackColor -1 bergeben, so setzen wir die
    ' RichTextBox Backcolor auf "auto"
    If NewSelFontBackColor = -1 Then
        udtChar.dwEffects = CFE_AUTOBACKCOLOR
        udtChar.crBackColor = -1
    Else
        ' der crBackColor Member bestimmt die Farbe:
        udtChar.crBackColor = TranslateColor(NewSelFontBackColor)
    End If
    
    ' Nun schicken wir dem Control eine EM_SETCHARFORMAT Message, und
    ' das Control bernimmt die farbe aus dem udtChar
    SendMessage RTFhwnd, EM_SETCHARFORMAT, SCF_SELECTION, udtChar
End Function

' Diese Funktion wird nur von der SetSelBackColor Funktion verwendet um
' eine RGB Farbe in eine Paletten Farbe umzuwandeln
Private Function TranslateColor(ByVal clr As OLE_COLOR, Optional hPal As Long = 0) As Long
    If OleTranslateColor(clr, hPal, TranslateColor) Then
        TranslateColor = -1
    End If
End Function
