Attribute VB_Name = "mdlEncryption"
Option Explicit

Public EncryptionKey As String
Public EncryptionKeyOld As String
Public EncryptionKennwort As String
Public EncryptionHinweis As String

'******************************************************************************
' Autor: Thomas Theiner

Public Function VernamCode(sOriginal As String, _
  sPassword As String) As String
  
  Dim i As Long
  Dim aktpos As Long
  Dim bAkt As Byte
  Dim bCode As Byte

  VernamCode = ""
    
  ' Passwort auf die Lnge des Klartextes bringen
  ' Dazu wird z.B. aus "Geheim" dann "GeheimGeheimGehe...."
  aktpos = 1
  For i = Len(sPassword) + 1 To Len(sOriginal)
    sPassword = sPassword & Mid(sPassword, aktpos, 1)
    aktpos = aktpos + 1
    If aktpos > Len(sPassword) Then aktpos = 1
  Next i
    
  For i = 1 To Len(sOriginal)
    bAkt = Asc(Mid(sOriginal, i, 1))
    bCode = Asc(Mid(sPassword, i, 1))
        
    VernamCode = VernamCode & Chr(bAkt Xor bCode)
  Next i
End Function

'******************************************************************************
' Autor: Thomas Hoffmann

Private Function VirtPos(i As Long, _
  a() As Integer) As Integer

  If i > UBound(a) Then
    VirtPos = VirtPos(i - UBound(a), a)
  Else
    VirtPos = a(i)
  End If
End Function

Private Function addToIndex(i As Integer, _
  j As Integer) As Integer

  If i + j > 255 Then
    addToIndex = i + j - 255
  Else
    addToIndex = i + j
  End If
End Function

Private Function GetOfIndex(i As Integer, _
  j As Integer) As Integer

  If i - j < 0 Then
    GetOfIndex = i - j + 255
  Else
    GetOfIndex = i - j
  End If
End Function

' Text in Verbindung mit einem Passwort entschlsseln
Public Function DecodeString(ByVal strToDecode As String, _
  ByVal strPassword As String) As String

  Dim strResult As String
  Dim i As Long
  Dim cfc() As Integer

  ReDim cfc(1 To Len(strPassword))
  ReDim ttc(1 To Len(strToDecode))

  For i = 1 To UBound(cfc)
    cfc(i) = Asc(Right(strPassword, _
      Len(strPassword) - i + 1))
  Next i

  For i = 1 To Len(strToDecode)
    strResult = strResult & _
      Chr(GetOfIndex(Asc(Right(strToDecode, _
      Len(strToDecode) - i + 1)), VirtPos(i, cfc)))
  Next i

  DecodeString = strResult
End Function

' Text in Verbindung mit einem Passwort verschlsseln
Public Function EncodeString(ByVal strToEncode As String, _
  ByVal strPassword As String) As String

  Dim strResult As String
  Dim i As Long
  Dim cfc() As Integer

  ReDim cfc(1 To Len(strPassword))

  For i = 1 To UBound(cfc)
    cfc(i) = Asc(Right(strPassword, _
      Len(strPassword) - i + 1))
  Next i

  For i = 1 To Len(strToEncode)
    strResult = strResult & _
      Chr(addToIndex(Asc(Right(strToEncode, _
      Len(strToEncode) - i + 1)), VirtPos(i, cfc)))
  Next i

  EncodeString = strResult
End Function
'******************************************************************************

Private Function GetBinary(number As Long) As String
On Error GoTo Err_GetBinary

Dim X As Long
Dim binstr As String
binstr = ""
number = number + 1
For X = 7 To 0 Step -1
    If number > 2 ^ X Then
        number = number - 2 ^ X
        binstr = binstr & "1"
    Else
        binstr = binstr & "0"
    End If
Next
GetBinary = binstr

Exit Function
Err_GetBinary:
MsgBox Err.Description, vbCritical, App.Title
End Function

Private Function BintoDec(binstr As String) As Long
On Error GoTo Err_BintoDec

Dim X As Long
Dim number As Long
For X = 0 To 7
    If Mid$(binstr, X + 1, 1) = "1" Then
        number = number + (2 ^ (7 - X))
    End If
Next
BintoDec = number

Exit Function
Err_BintoDec:
MsgBox Err.Description, vbCritical, App.Title
End Function

Public Sub DecryptBin()
On Error GoTo Fehlerbehandlung

Dim X
Dim DecryptStr As String
Dim DecryptKey As String, TempDecryptKey As String
Dim DecryptLen As Long
Dim DecryptPos As Long
Dim DecryptKeyPos As Long
Dim tempChar As String
Dim TA As Long, TB As Long, TC As Long

With FrmEditor
        EncryptionKennwort = GetSetting(App.Title, "Setting", "sCryptKW", "")
        
        If EncryptionKennwort <> "" Then
        
            With FrmInPutBox
                .Caption = FrmEditor.mnuBinDecrypt.Caption
                .Show vbModal
                If .sKennwort <> EncryptionKennwort Then
                    Call PlayFehlerSound
                    MsgBox "Das eingegebene Kennwort ist falsch!", vbExclamation, "falsches Kennwort"
                    Call PlayClickSound
                    Exit Sub
                End If
            End With
        End If
        
EncryptionKey = GetSetting(App.Title, "Setting", "EncryptionKey", "")
EncryptionKeyOld = EncryptionKey

Call PlayFensterffnenSound
            With FrmEncryptionInPutBox
                .lblHinweis.Caption = "Gib deinen Entschlsselungs-Code ein." & vbCrLf _
                & vbCrLf & "Dieser Entschlsselungs-Code bestimmt den Entschlsselungsgrad."
                .Caption = "Entschlsseln"
                .txtEingabe.Text = EncryptionKey
                .txtLenEncryptionKey.Text = Len(EncryptionKey)
                .cmdKey.Caption = "Entschlsselungs-Code generieren"
                .Show vbModal
                TempDecryptKey = .strEncryptionKey
'                MsgBox .strEncryptionKey, vbInformation, ".strEncryptionKey"
            End With
        
        If TempDecryptKey = "" Or Len(TempDecryptKey) < 4 Then
            Call PlayHinweisSound
            If TempDecryptKey = "" Then
                MsgBox "Du hast keinen Entschlsselungs-Code eingegeben !", _
                vbExclamation, "Entschlsseln abgebrochen"
            Else
                MsgBox "Dein Entschlsselungs-Code ist zu klein um eine sichere Entschlsselung zu gewhrleisten !" _
                & vbCrLf & "Er sollte mindestens 4 Zeichen lang sein.", vbExclamation, "Entschlsseln abgebrochen"
            End If
            Exit Sub
        End If
        
EncryptionKey = TempDecryptKey

If EncryptionKey <> EncryptionKeyOld Then
    Call PlayFrageSound
    If MsgBox("Dein Ver- bzw. Entschlsselungs-Code wurde gendert!" & vbCrLf _
    & "Soll dein Ver- bzw. Entschlsselungs-Code gespeichert werden ?", _
    vbQuestion + vbYesNo + vbDefaultButton1, "Ver- bzw. Entschlsselungs-Code speichern") = vbYes Then
        'es wird nur dieser Encryption-Key in der Registrie gespeichert
        SaveSetting App.Title, "Setting", "EncryptionKey", TempDecryptKey
    End If
End If

DecryptStr = ""
DecryptPos = 1
DecryptKeyPos = 1
For X = 1 To Len(TempDecryptKey)
    DecryptKey = DecryptKey & Asc(Mid$(TempDecryptKey, X, 1))
Next
    DecryptLen = Len(DecryptKey)

Screen.MousePointer = 13
    .Timer1.Enabled = False
    .StatusBar1.Panels(5).Text = "Entschlsselungsvorgang, bitte warten"
    
    For X = 1 To Len(.RichTextBox1.Text) Step 8
        TB = Asc(Mid$(DecryptKey, DecryptKeyPos, 1))
        DecryptKeyPos = DecryptKeyPos + 1
        
        If DecryptKeyPos > DecryptLen Then DecryptKeyPos = 1
        
        tempChar = Mid$(.RichTextBox1.Text, X, 8)
        TA = BintoDec(tempChar)
        TC = TB Xor TA
        DecryptStr = DecryptStr & Chr$(TC)
    Next
    .RichTextBox1.Text = DecryptStr
    
    .Timer1.Enabled = True
    .StatusBar1.Panels(5).Text = "Entschlsselungsvorgang beendet!"
End With
Screen.MousePointer = vbDefault

Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub DecryptHex()
On Error GoTo Fehlerbehandlung

Dim X
Dim DecryptStr As String
Dim DecryptKey As String, TempDecryptKey As String
Dim DecryptLen As Long
Dim DecryptPos As Long
Dim DecryptKeyPos As Long
Dim tempChar As String
Dim TA As Long, TB As Long, TC As Long

With FrmEditor
        EncryptionKennwort = GetSetting(App.Title, "Setting", "sCryptKW", "")
        
        If EncryptionKennwort <> "" Then
        
            With FrmInPutBox
                .Caption = FrmEditor.mnuHexDecrypt.Caption
                .Show vbModal
                If .sKennwort <> EncryptionKennwort Then
                    Call PlayFehlerSound
                    MsgBox "Das eingegebene Kennwort ist falsch!", vbExclamation, "falsches Kennwort"
                    Call PlayClickSound
                    Exit Sub
                End If
            End With
        End If
        
EncryptionKey = GetSetting(App.Title, "Setting", "EncryptionKey", "")
EncryptionKeyOld = EncryptionKey

Call PlayFensterffnenSound
            With FrmEncryptionInPutBox
                .lblHinweis.Caption = "Gib deinen Entschlsselungs-Code ein." & vbCrLf _
                & vbCrLf & "Dieser Entschlsselungs-Code bestimmt den Entschlsselungsgrad."
                .Caption = "Entschlsseln"
                .txtEingabe.Text = EncryptionKey
                .txtLenEncryptionKey.Text = Len(EncryptionKey)
                .cmdKey.Caption = "Entschlsselungs-Code generieren"
                .Show vbModal
                TempDecryptKey = .strEncryptionKey
'                MsgBox .strEncryptionKey, vbInformation, ".strEncryptionKey"
            End With
        
        If TempDecryptKey = "" Or Len(TempDecryptKey) < 4 Then
            Call PlayHinweisSound
            If TempDecryptKey = "" Then
                MsgBox "Du hast keinen Entschlsselungs-Code eingegeben !", _
                vbExclamation, "Entschlsseln abgebrochen"
            Else
                MsgBox "Dein Entschlsselungs-Code ist zu klein um eine sichere Entschlsselung zu gewhrleisten !" _
                & vbCrLf & "Er sollte mindestens 4 Zeichen lang sein.", vbExclamation, "Entschlsseln abgebrochen"
            End If
            Exit Sub
        End If
        
EncryptionKey = TempDecryptKey

If EncryptionKey <> EncryptionKeyOld Then
    Call PlayFrageSound
    If MsgBox("Dein Ver- bzw. Entschlsselungs-Code wurde gendert!" & vbCrLf _
    & "Soll dein Ver- bzw. Entschlsselungs-Code gespeichert werden ?", _
    vbQuestion + vbYesNo + vbDefaultButton1, "Ver- bzw. Entschlsselungs-Code speichern") = vbYes Then
        'es wird nur dieser Encryption-Key in der Registrie gespeichert
        SaveSetting App.Title, "Setting", "EncryptionKey", TempDecryptKey
    End If
End If

DecryptStr = ""
DecryptPos = 1
DecryptKeyPos = 1
For X = 1 To Len(TempDecryptKey)
    DecryptKey = DecryptKey & Asc(Mid$(TempDecryptKey, X, 1))
Next
DecryptLen = Len(DecryptKey)

Screen.MousePointer = 13
    .Timer1.Enabled = False
    .StatusBar1.Panels(5).Text = "Entschlsselungsvorgang, bitte warten"
    
    For X = 1 To Len(.RichTextBox1.Text) Step 2
        TB = Asc(Mid$(DecryptKey, DecryptKeyPos, 1))
        DecryptKeyPos = DecryptKeyPos + 1
        
        If DecryptKeyPos > DecryptLen Then DecryptKeyPos = 1
        
        tempChar = Mid$(.RichTextBox1.Text, X, 2)
        TA = Val("&H" + tempChar)
        TC = TB Xor TA
        DecryptStr = DecryptStr & Chr$(TC)
    Next
    .RichTextBox1.Text = DecryptStr
    
    .Timer1.Enabled = True
    .StatusBar1.Panels(5).Text = "Entschlsselungsvorgang beendet!"
End With
Screen.MousePointer = vbDefault

Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub EncryptBin()
On Error GoTo Fehlerbehandlung

Dim X
Dim EncryptStr As String
Dim EncryptKey As String, TempEncryptKey As String
Dim EncryptLen As Long
Dim EncryptPos As Long
Dim EncryptKeyPos As Long
Dim tempChar As String
Dim TA As Long, TB As Long, TC As Long

With FrmEditor
Dim str As String
    str = .RichTextBox1.Text
    If Len(str) > 2000 Then
        Call PlayHinweisSound
        MsgBox "Der Text ist zu lang, Aktion wird nicht ausgefhrt!", vbExclamation, "Text zu lang"
        Call PlayClickSound
        Exit Sub
    End If
        EncryptionKennwort = GetSetting(App.Title, "Setting", "sCryptKW", "")
        
        If EncryptionKennwort <> "" Then
        
            With FrmInPutBox
                .Caption = FrmEditor.mnuBinEncrypt.Caption
                .Show vbModal
                If .sKennwort <> EncryptionKennwort Then
                    Call PlayFehlerSound
                    MsgBox "Das eingegebene Kennwort ist falsch!", vbExclamation, "falsches Kennwort"
                    Call PlayClickSound
                    Exit Sub
                End If
            End With
        End If
        
EncryptionKey = GetSetting(App.Title, "Setting", "EncryptionKey", "")
EncryptionKeyOld = EncryptionKey

Call PlayFensterffnenSound
            With FrmEncryptionInPutBox
                .lblHinweis.Caption = "Gib deinen Verschlsselungs-Code ein." & vbCrLf _
                & vbCrLf & "Dieser Verschlsselungs-Code bestimmt den Verschlsselungsgrad."
                .Caption = "Verschlsseln"
                .txtEingabe.Text = EncryptionKey
                .txtLenEncryptionKey.Text = Len(EncryptionKey)
                .cmdKey.Caption = "Verschlsselungs-Code generieren"
                .Show vbModal
                TempEncryptKey = .strEncryptionKey
                If .bolEncryptionKey = False Then
                    Call PlayAblehnenSound
                    Exit Sub
                End If
'                MsgBox .strEncryptionKey, vbInformation, ".strEncryptionKey"
            End With
        
        If TempEncryptKey = "" Or Len(TempEncryptKey) < 4 Then
            Call PlayHinweisSound
            If TempEncryptKey = "" Then
                MsgBox "Du hast keinen Verschlsselungs-Code eingegeben !", _
                vbExclamation, "Verschlsseln abgebrochen"
            Else
                MsgBox "Dein Verschlsselungs-Code ist zu klein um eine sichere Verschlsselung zu gewhrleisten !" _
                & vbCrLf & "Er sollte mindestens 4 Zeichen lang sein.", vbExclamation, "Verschlsseln abgebrochen"
            End If
            Exit Sub
        End If
        
EncryptionKey = TempEncryptKey

If EncryptionKey <> EncryptionKeyOld Then
    Call PlayFrageSound
    If MsgBox("Dein Ver- bzw. Entschlsselungs-Code wurde gendert!" & vbCrLf _
    & "Soll dein Ver- bzw. Entschlsselungs-Code gespeichert werden ?", _
    vbQuestion + vbYesNo + vbDefaultButton1, "Ver- bzw. Entschlsselungs-Code speichern") = vbYes Then
        'es wird nur dieser Encryption-Key in der Registrie gespeichert
        SaveSetting App.Title, "Setting", "EncryptionKey", TempEncryptKey
    End If
End If

EncryptStr = ""
EncryptPos = 1
EncryptKeyPos = 1

For X = 1 To Len(TempEncryptKey)
    EncryptKey = EncryptKey & Asc(Mid$(TempEncryptKey, X, 1))
Next

EncryptLen = Len(EncryptKey)

Screen.MousePointer = 13
    .Timer1.Enabled = False
    .StatusBar1.Panels(5).Text = "Verschlsselungsvorgang, bitte warten"
    
    For X = 1 To Len(.RichTextBox1.Text)
        TB = Asc(Mid$(EncryptKey, EncryptKeyPos, 1))
        EncryptKeyPos = EncryptKeyPos + 1
        
        If EncryptKeyPos > EncryptLen Then EncryptKeyPos = 1
        
        TA = Asc(Mid$(.RichTextBox1.Text, X, 1))
        TC = TB Xor TA
        tempChar = GetBinary(TC)
        EncryptStr = EncryptStr & tempChar
    Next
    
    .Timer1.Enabled = True
    .StatusBar1.Panels(5).Text = "Verschlsselungsvorgang beendet!"
End With
FrmEditor.RichTextBox1.Text = EncryptStr

Screen.MousePointer = vbDefault

Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub EncryptHex()
On Error GoTo Fehlerbehandlung

Dim X
Dim EncryptStr As String
Dim EncryptKey As String, TempEncryptKey As String
Dim EncryptLen As Long
Dim EncryptPos As Long
Dim EncryptKeyPos As Long
Dim tempChar As String
Dim TA As Long, TB As Long, TC As Long

With FrmEditor
Dim str As String
    str = .RichTextBox1.Text
    If Len(str) > 2000 Then
        Call PlayHinweisSound
        MsgBox "Der Text ist zu lang, Aktion wird nicht ausgefhrt!", vbExclamation, "Text zu lang"
        Call PlayClickSound
        Exit Sub
    End If
        EncryptionKennwort = GetSetting(App.Title, "Setting", "sCryptKW", "")
        
        If EncryptionKennwort <> "" Then
        
            With FrmInPutBox
                .Caption = FrmEditor.mnuHexEncrypt.Caption
                .Show vbModal
                If .sKennwort <> EncryptionKennwort Then
                    Call PlayFehlerSound
                    MsgBox "Das eingegebene Kennwort ist falsch!", vbExclamation, "falsches Kennwort"
                    Call PlayClickSound
                    Exit Sub
                End If
            End With
        End If
        
EncryptionKey = GetSetting(App.Title, "Setting", "EncryptionKey", "")
EncryptionKeyOld = EncryptionKey

Call PlayFensterffnenSound
            With FrmEncryptionInPutBox
                .lblHinweis.Caption = "Gib deinen Verschlsselungs-Code ein." & vbCrLf _
                & vbCrLf & "Dieser Verschlsselungs-Code bestimmt den Verschlsselungsgrad."
                .Caption = "Verschlsseln"
                .txtEingabe.Text = EncryptionKey
                .txtLenEncryptionKey.Text = Len(EncryptionKey)
                .cmdKey.Caption = "Verschlsselungs-Code generieren"
                .Show vbModal
                TempEncryptKey = .strEncryptionKey
                If .bolEncryptionKey = False Then
                    Call PlayAblehnenSound
                    Exit Sub
                End If
'                MsgBox .strEncryptionKey, vbInformation, ".strEncryptionKey"
            End With
        
        If TempEncryptKey = "" Or Len(TempEncryptKey) < 4 Then
            Call PlayHinweisSound
            If TempEncryptKey = "" Then
                MsgBox "Du hast keinen Verschlsselungs-Code eingegeben !", _
                vbExclamation, "Verschlsseln abgebrochen"
            Else
                MsgBox "Dein Verschlsselungs-Code ist zu klein um eine sichere Verschlsselung zu gewhrleisten !" _
                & vbCrLf & "Er sollte mindestens 4 Zeichen lang sein.", vbExclamation, "Verschlsseln abgebrochen"
            End If
            Exit Sub
        End If
        
EncryptionKey = TempEncryptKey

If EncryptionKey <> EncryptionKeyOld Then
    Call PlayFrageSound
    If MsgBox("Dein Ver- bzw. Entschlsselungs-Code wurde gendert!" & vbCrLf _
    & "Soll dein Ver- bzw. Entschlsselungs-Code gespeichert werden ?", _
    vbQuestion + vbYesNo + vbDefaultButton1, "Ver- bzw. Entschlsselungs-Code speichern") = vbYes Then
        'es wird nur dieser Encryption-Key in der Registrie gespeichert
        SaveSetting App.Title, "Setting", "EncryptionKey", TempEncryptKey
    End If
End If

EncryptStr = ""
EncryptPos = 1
EncryptKeyPos = 1

For X = 1 To Len(TempEncryptKey)
    EncryptKey = EncryptKey & Asc(Mid$(TempEncryptKey, X, 1))
Next

EncryptLen = Len(EncryptKey)

Screen.MousePointer = 13
    .Timer1.Enabled = False
    .StatusBar1.Panels(5).Text = "Verschlsselungsvorgang, bitte warten"
    
    For X = 1 To Len(FrmEditor.RichTextBox1.Text)
        TB = Asc(Mid$(EncryptKey, EncryptKeyPos, 1))
        EncryptKeyPos = EncryptKeyPos + 1
        
        If EncryptKeyPos > EncryptLen Then EncryptKeyPos = 1
        
        TA = Asc(Mid$(FrmEditor.RichTextBox1.Text, X, 1))
        TC = TB Xor TA
        tempChar = Hex$(TC)
        If Len(tempChar) < 2 Then tempChar = "0" & tempChar
        EncryptStr = EncryptStr & tempChar
    Next
    FrmEditor.RichTextBox1.Text = EncryptStr
    
    .Timer1.Enabled = True
    .StatusBar1.Panels(5).Text = "Verschlsselungsvorgang beendet!"
End With
Screen.MousePointer = vbDefault

Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub
