Attribute VB_Name = "mdlFeiertage"
Option Explicit

Enum eFeiertage
    Weiberfastnacht = -52
    Fastnacht = -47
    Rosenmontag = -48
    Aschermittwoch = -46
    Grndonnerstag = -3
    Karfreitag = -2
    Karsamstag = -1
    Ostersonntag = 0
    Ostermontag = 1
    Christihimmelfahrt = 39
    Pfingstsonntag = 49
    Pfingstmontag = 50
    Fronleichnam = 60
End Enum

Dim Muttertag As Date
Dim Erntedankfest As Date
Dim Valentinstag As Date
Dim EisheiligenMamertus As Date
Dim EisheiligenPankratius As Date
Dim EisheiligenServatius As Date
Dim EisheiligenBonifatius As Date
Dim EisheiligenkalteSophie As Date
Dim Siebenschlfertag As Date
Dim Friedensfest As Date
Dim MariaHimmelfahrt As Date
Dim Reformationstag As Date
Dim Allerseelen As Date
Dim Nikolaus As Date
Dim Heiligabend As Date
Dim Silvester As Date
Dim vierterAdvent As Date
Dim dritterAdvent As Date
Dim zweiterAdvent As Date
Dim ersterAdvent As Date
Dim BuundBettag As Date
Dim Totensonntag As Date
Dim Volkstrauertag As Date

'der Schferlauf-Sonntag
Dim s_Freitag As Date
Dim s_Samstag As Date
Dim S_Sonntag As Date
Dim s_Montag As Date
Dim sm_Freitag As Date
Dim sm_Samstag As Date
Dim sm_Sonntag As Date
Dim sm_Montag As Date


Public Neujahr As Date
Public HeiligeDreiKnige As Date
Public ErsterMai As Date
Public TgdtEinheit As Variant
Public Allerheiligen As Date
Public ErsterWeihnachtsfeiertag As Date
Public ZweiterWeihnachtsfeiertag As Date
Public valFeiertagdatum As Date            'Variable fr die Aufnahme eines Feiertagdatums

'Variablen fr die Korrekte Einstellung und nderung der Kalenderwoche

'vbUseSystemDayOfWeek (Voreinstellung System) = 0
'vbSunday (Sonntag) = 1
'vbMonday (Montag) = 2
'vbTuesday (Dienstag) = 3
'vbWednesday (Mittwoch) = 4
'vbThursday (Donnerstag) = 5
'vbFriday (Freitag) = 6
'vbSaturday (Samstag) = 7
Public StartDayofWeek As VbDayOfWeek

'vbUseSystem = 0
'vbFirstJan1 = 1
'vbFirstFourDays = 2
'vbFirstFullWeek = 3
Public StartWeekofYear As VbFirstWeekOfYear

Public DatumamFeiertag As Boolean

Enum cSchferlauf
    cMusikFreitag = -9
    cMusikSamstag = -8
    cMusikSonntag = -7
    cFreitag = -2
    cSamstag = -1
    cSonntag = 0
    cMontag = 1
End Enum

' SchferlaufSonntag berechnen
Private Function getSchferlaufSonntag(ByVal intJahr As Long, _
Optional cTag As cSchferlauf) As Date

On Error GoTo Fehlerbehandlung
  Dim i As Long
  
  For i = 31 To 1 Step -1
    If Format$(i & ".08." & intJahr, "ddd") = "So" Then
      getSchferlaufSonntag = Format$(i & ".08." & intJahr, "dd.mm.yyyy")
      Exit For
    End If
  Next i

Exit Function
Fehlerbehandlung:
End Function


' 4. Advent berechnen
Private Function GetViertenAdvent(ByVal intJahr As Long) As Date
On Error GoTo Fehlerbehandlung
  Dim i As Long
  
  For i = 24 To 1 Step -1
    If Format$(i & ".12." & intJahr, "ddd") = "So" Then
      GetViertenAdvent = Format$(i & ".12." & intJahr, "dd.mm.yyyy")
      Exit For
    End If
  Next i
Exit Function
Fehlerbehandlung:
End Function

' Muttertag berechnen
Private Function GetMuttertag(ByVal intJahr As Long) As Date
On Error GoTo Fehlerbehandlung
  Dim w1 As Boolean
  Dim i As Long
  
  w1 = False
  For i = 1 To 31
    If Format$(i & ".5." & intJahr, "ddd") = "So" Then
      If w1 = True Then
        GetMuttertag = Format$(i & ".5." & intJahr, "dd.mm.yyyy")
        Exit For
      Else
        w1 = True
      End If
    End If
  Next i
Exit Function
Fehlerbehandlung:
End Function

' Erntedank berechnen
Private Function GetErntedankfest(ByVal intJahr As Long) As Date
On Error GoTo Fehlerbehandlung
  Dim i As Long
  
  For i = 1 To 16
    If Format$(i & ".5." & intJahr, "ddd") = "So" Then
      GetErntedankfest = Format$(i & ".10." & intJahr, "dd.mm.yyyy")
      Exit For
    End If
  Next i
Exit Function
Fehlerbehandlung:
End Function


Public Function FeiertagDatum(ByVal intJahr As Integer, Optional Feiertag As eFeiertage) As Date

    Dim x As Integer, k As Integer, m As Integer
    Dim s As Integer, a As Integer, D As Integer
    Dim r As Integer, OG As Integer, SZ As Integer
    Dim OE As Integer, OS As Integer
    Dim Monat As Integer
    
    'intJahr ist der Wert des Combinationsfeldes
    x = intJahr
    'Eingabewert / 100
    k = Int(x / 100)
    
    m = 15 + Int((k * 3 + 3) / 4) - Int((k * 8 + 13) / 25)
    
    s = 2 - Int((3 * k + 3) / 4)
    
    a = x Mod 19
    
    D = (19 * a + m) Mod 30
    
    r = Int(D / 29) + (Int(D / 28) - Int(D / 29)) * Int(a / 11)
    
    OG = 21 + D - r
    
    SZ = 7 - (x + Int(x / 4) + s) Mod 7
    
    OE = 7 - (OG - SZ) Mod 7
    
    OS = OG + OE
    
    Monat = 3
    
If OS > 31 Then
    OS = OS - 31
    Monat = Monat + 1
End If

FeiertagDatum = DateSerial(x, Monat, OS)
    
    Select Case Feiertag
    
        Case eFeiertage.Weiberfastnacht
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Weiberfastnacht)
    
        Case eFeiertage.Fastnacht
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Fastnacht)
    
        Case eFeiertage.Rosenmontag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Rosenmontag)
            
        Case eFeiertage.Aschermittwoch
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Aschermittwoch)
            
        Case eFeiertage.Grndonnerstag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Grndonnerstag)
            
        Case eFeiertage.Karfreitag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Karfreitag)
            
        Case eFeiertage.Karsamstag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Karsamstag)
            
        Case eFeiertage.Ostersonntag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Ostersonntag)
            
        Case eFeiertage.Ostermontag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Ostermontag)

        Case eFeiertage.Christihimmelfahrt
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Christihimmelfahrt)
            
        Case eFeiertage.Pfingstsonntag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Pfingstsonntag)
            
        Case eFeiertage.Pfingstmontag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Pfingstmontag)
            
        Case eFeiertage.Fronleichnam
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Fronleichnam)
            
        Case Else
    End Select
End Function

Public Function strFeiertag(ByVal Jahr As Integer, ByVal datum As Date) As String

DatumamFeiertag = False

'die entsprechenden Werte fr das Musikfest und den Schferlauf ermitteln
'zuerst den Schferlauf-Sonntag
S_Sonntag = getSchferlaufSonntag(Jahr)

sm_Freitag = DateAdd("d", -9, S_Sonntag)
sm_Samstag = DateAdd("d", -8, S_Sonntag)
sm_Sonntag = DateAdd("d", -7, S_Sonntag)
sm_Montag = DateAdd("d", -6, S_Sonntag)

s_Freitag = DateAdd("d", -2, S_Sonntag)
s_Samstag = DateAdd("d", -1, S_Sonntag)
s_Montag = DateAdd("d", 1, S_Sonntag)


Neujahr = "01.01." & Jahr
HeiligeDreiKnige = "06.01." & Jahr
Valentinstag = "14.02." & Jahr
ErsterMai = "01.05." & Jahr
EisheiligenMamertus = "11.05." & Jahr
EisheiligenPankratius = "12.05." & Jahr
EisheiligenServatius = "13.05." & Jahr
EisheiligenBonifatius = "14.05." & Jahr
EisheiligenkalteSophie = "15.05." & Jahr
Siebenschlfertag = "27.06." & Jahr
Friedensfest = "08.08." & Jahr
MariaHimmelfahrt = "15.08." & Jahr
Reformationstag = "31.10." & Jahr
Nikolaus = "06.12." & Jahr
Allerheiligen = "01.11." & Jahr
Allerseelen = "2.11." & Jahr
Heiligabend = "24.12." & Jahr
ErsterWeihnachtsfeiertag = "25.12." & Jahr
ZweiterWeihnachtsfeiertag = "26.12." & Jahr
Silvester = "31.12." & Jahr
Muttertag = GetMuttertag(Jahr)
Erntedankfest = GetErntedankfest(Jahr)
vierterAdvent = GetViertenAdvent(Jahr)
dritterAdvent = DateAdd("d", -7, GetViertenAdvent(Jahr))
zweiterAdvent = DateAdd("d", -14, GetViertenAdvent(Jahr))
ersterAdvent = DateAdd("d", -21, GetViertenAdvent(Jahr))
BuundBettag = DateAdd("d", -11, ersterAdvent)
Totensonntag = DateAdd("d", -28, GetViertenAdvent(Jahr))
Volkstrauertag = DateAdd("d", -35, GetViertenAdvent(Jahr))
If Jahr < 1954 Then TgdtEinheit = ""
If Jahr >= 1954 And Jahr <= 1989 Then TgdtEinheit = DateSerial(Jahr, 6, 17)
If Jahr > 1989 Then TgdtEinheit = DateSerial(Jahr, 10, 3)
            
    Select Case datum
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Weiberfastnacht)
            strFeiertag = "Weiber Fastnacht"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Fastnacht)
            strFeiertag = "Fastnacht"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Weiberfastnacht)
            strFeiertag = "Weiber Fastnacht"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Aschermittwoch)
            DatumamFeiertag = True
            strFeiertag = "Aschermittwoch"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Rosenmontag)
            strFeiertag = "Rosenmontag"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Grndonnerstag)
            strFeiertag = "Grndonnerstag"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Karfreitag)
            DatumamFeiertag = True
            strFeiertag = "Karfreitag"
        
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Karsamstag)
            strFeiertag = "Karsamstag"
            
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Ostersonntag)
            DatumamFeiertag = True
            strFeiertag = "Ostersonntag"
            
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Ostermontag)
            DatumamFeiertag = True
            strFeiertag = "Ostermontag"
            
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Christihimmelfahrt)
            DatumamFeiertag = True
            strFeiertag = "Christihimmelfahrt"
            
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Pfingstsonntag)
            DatumamFeiertag = True
            strFeiertag = "Pfingstsonntag"
            
        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Pfingstmontag)
            DatumamFeiertag = True
            strFeiertag = "Pfingstmontag"
            
        Case Valentinstag
            strFeiertag = "Valentinstag"
  
        Case EisheiligenMamertus
            strFeiertag = "Eisheiligen: Mamertus"
            
        Case EisheiligenPankratius
            strFeiertag = "Eisheiligen: Pankratius"
            
        Case EisheiligenServatius
            strFeiertag = "Eisheiligen: Servatius"
            
        Case EisheiligenBonifatius
            strFeiertag = "Eisheiligen: Bonifatius"
            
        Case EisheiligenkalteSophie
            strFeiertag = "Eisheiligen: kalte Sophie"
            
        Case MariaHimmelfahrt
            strFeiertag = "Maria Himmelfahrt"

        Case S_Sonntag
            strFeiertag = "Schferlauf - Sonntag"
            
        Case sm_Freitag
            strFeiertag = "Musikfest - Freitag"

        Case sm_Samstag
            strFeiertag = "Musikfest - Samstag"

        Case sm_Sonntag
            strFeiertag = "Musikfest - Sonntag"

        Case sm_Montag
            strFeiertag = "Musikfest - Montag"

        Case s_Freitag
            strFeiertag = "Schferlauf - Freitag"

        Case s_Samstag
            strFeiertag = "Schferlauf - Samstag"

        Case s_Montag
            strFeiertag = "Schferlauf - Montag"

        Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Fronleichnam)
            DatumamFeiertag = True
            strFeiertag = "Fronleichnam"
            
        Case Muttertag
            strFeiertag = "Muttertag"
            
        Case Friedensfest
            strFeiertag = "Friedensfest"
            
        Case Erntedankfest
            strFeiertag = "Erntedankfest"
            
        Case Neujahr
            DatumamFeiertag = True
            strFeiertag = "Neujahr"
            
        Case HeiligeDreiKnige
            DatumamFeiertag = True
            strFeiertag = "Heilige Drei Knige"
            
        Case ErsterMai
            DatumamFeiertag = True
            strFeiertag = "Tag der Arbeit"

        Case Siebenschlfertag
            strFeiertag = "Siebenschlfertag"

        Case TgdtEinheit
            If TgdtEinheit <> "" Then
                DatumamFeiertag = True
                strFeiertag = "Tag der deutschen Einheit"
            End If
            
        Case Allerheiligen
            DatumamFeiertag = True
            strFeiertag = "Allerheiligen"
        
        Case Allerseelen
            strFeiertag = "Allerseelen"
        
        Case Reformationstag
            strFeiertag = "Reformationstag"
            
        Case Volkstrauertag
            strFeiertag = "Volkstrauertag"
            
        Case Totensonntag
            strFeiertag = "Totensonntag"
            
        Case BuundBettag
            strFeiertag = "Bu- und Bettag"
            
        Case Nikolaus
            strFeiertag = "Nikolaus"
            
        Case ersterAdvent
            strFeiertag = "1. Advent"
            
        Case zweiterAdvent
            strFeiertag = "2. Advent"
            
        Case dritterAdvent
            strFeiertag = "3. Advent"
            
        Case vierterAdvent
            strFeiertag = "4. Advent"
            
        Case Heiligabend
           strFeiertag = "Heiligabend"
        
        Case ErsterWeihnachtsfeiertag
            DatumamFeiertag = True
            strFeiertag = "1. Weihnachtsfeiertag"
            
        Case ZweiterWeihnachtsfeiertag
            DatumamFeiertag = True
            strFeiertag = "2. Weihnachtsfeiertag"
        
        Case Silvester
            strFeiertag = "Silvester"
            
        Case Else
            DatumamFeiertag = False
            strFeiertag = ""
    End Select

End Function

Public Sub Feiertageanzeigen(ByVal Jahr As Integer)

Neujahr = "01.01." & Jahr
HeiligeDreiKnige = "06.01." & Jahr
ErsterMai = "01.05." & Jahr
Allerheiligen = "01.11." & Jahr
ErsterWeihnachtsfeiertag = "25.12." & Jahr
ZweiterWeihnachtsfeiertag = "26.12." & Jahr
Silvester = "31.12." & Jahr

If Jahr < 1954 Then TgdtEinheit = ""
If Jahr >= 1954 And Jahr <= 1989 Then TgdtEinheit = DateSerial(Jahr, 6, 17)
If Jahr > 1989 Then TgdtEinheit = DateSerial(Jahr, 10, 3)
            
Dim i As Integer
'alle Feiertage den entsprechenden Jahres anzeigen
With FrmFeiertage.MSFlexGridFeiertage
    .Height = 4700
    .Width = 4250

    If TgdtEinheit <> "" Then
        .Rows = 16
        .Cols = 3
        .ColWidth(0) = 500
        .ColWidth(1) = 2500
        
        .TextMatrix(0, 0) = "ID.:"
        .TextMatrix(0, 1) = "Feiertag:"
        .TextMatrix(0, 2) = "Datum:"
    
        For i = 1 To 15
            .TextMatrix(i, 0) = i
        Next
        .TextMatrix(1, 1) = "Neujahr"
        .TextMatrix(1, 2) = Neujahr
        .TextMatrix(2, 1) = "Heilige drei Knige"
        .TextMatrix(2, 2) = HeiligeDreiKnige
        .TextMatrix(3, 1) = "Aschermittwoch"
        .TextMatrix(3, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Aschermittwoch)
        .TextMatrix(4, 1) = "Karfreitag"
        .TextMatrix(4, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Karfreitag)
        .TextMatrix(5, 1) = "Ostersonntag"
        .TextMatrix(5, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Ostersonntag)
        .TextMatrix(6, 1) = "Ostermontag"
        .TextMatrix(6, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Ostermontag)
        .TextMatrix(7, 1) = "Tag der Arbeit"
        .TextMatrix(7, 2) = ErsterMai
        .TextMatrix(8, 1) = "Christi Himmelfahrt"
        .TextMatrix(8, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Christihimmelfahrt)
        .TextMatrix(9, 1) = "Pfingstsonntag"
        .TextMatrix(9, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Pfingstsonntag)
        .TextMatrix(10, 1) = "Pfingstmontag"
        .TextMatrix(10, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Pfingstmontag)
        .TextMatrix(11, 1) = "Fronleichnam"
        .TextMatrix(11, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Fronleichnam)
        .TextMatrix(12, 1) = "Tag der deutschen Einheit"
        .TextMatrix(12, 2) = TgdtEinheit
        .TextMatrix(13, 1) = "Allerheiligen"
        .TextMatrix(13, 2) = Allerheiligen
        .TextMatrix(14, 1) = "1. Weihnachtsfeiertag"
        .TextMatrix(14, 2) = ErsterWeihnachtsfeiertag
        .TextMatrix(15, 1) = "2. Weihnachtsfeiertag"
        .TextMatrix(15, 2) = ZweiterWeihnachtsfeiertag
    Else
        .Rows = 15
        .Cols = 3
        .ColWidth(0) = 500
        .ColWidth(1) = 2500
        
        .TextMatrix(0, 0) = "ID.:"
        .TextMatrix(0, 1) = "Feiertag:"
        .TextMatrix(0, 2) = "Datum:"
    
        For i = 1 To 14
            .TextMatrix(i, 0) = i
        Next
        .TextMatrix(1, 1) = "Neujahr"
        .TextMatrix(1, 2) = Neujahr
        .TextMatrix(2, 1) = "Heilige drei Knige"
        .TextMatrix(2, 2) = HeiligeDreiKnige
        .TextMatrix(3, 1) = "Aschermittwoch"
        .TextMatrix(3, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Aschermittwoch)
        .TextMatrix(4, 1) = "Karfreitag"
        .TextMatrix(4, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Karfreitag)
        .TextMatrix(5, 1) = "Ostersonntag"
        .TextMatrix(5, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Ostersonntag)
        .TextMatrix(6, 1) = "Ostermontag"
        .TextMatrix(6, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Ostermontag)
        .TextMatrix(7, 1) = "Tag der Arbeit"
        .TextMatrix(7, 2) = ErsterMai
        .TextMatrix(8, 1) = "Christi Himmelfahrt"
        .TextMatrix(8, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Christihimmelfahrt)
        .TextMatrix(9, 1) = "Pfingstsonntag"
        .TextMatrix(9, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Pfingstsonntag)
        .TextMatrix(10, 1) = "Pfingstmontag"
        .TextMatrix(10, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Pfingstmontag)
        .TextMatrix(11, 1) = "Fronleichnam"
        .TextMatrix(11, 2) = FeiertagDatum(intJahr:=Jahr, Feiertag:=Fronleichnam)
        .TextMatrix(12, 1) = "Allerheiligen"
        .TextMatrix(12, 2) = Allerheiligen
        .TextMatrix(13, 1) = "1. Weihnachtsfeiertag"
        .TextMatrix(13, 2) = ErsterWeihnachtsfeiertag
        .TextMatrix(14, 1) = "2. Weihnachtsfeiertag"
        .TextMatrix(14, 2) = ZweiterWeihnachtsfeiertag
    End If

End With
End Sub

Public Function fktJahreszeit(ByVal datum As Date, ByVal iJahr As Integer) As String

Const Frhlingsanfang = "20.03."
Const Sommeranfang = "21.06."
Const Herbstanfang = "22.09."
Const Winteranfang = "21.12."

Select Case datum
    Case Is < Frhlingsanfang & Right(datum, 4)
        fktJahreszeit = "Jahreszeit : Winter ( von : " _
        & Winteranfang & iJahr - 1 & "  bis : " _
        & DateAdd("d", -1, Frhlingsanfang & iJahr) & " )"
        
    Case Is < Sommeranfang & Right(datum, 4)
        fktJahreszeit = "Jahreszeit : Frhling ( von : " _
        & Frhlingsanfang & iJahr & "  bis : " _
        & DateAdd("d", -1, Sommeranfang & iJahr) & " )"
        
    Case Is < Herbstanfang & Right(datum, 4)
        fktJahreszeit = "Jahreszeit : Sommer ( von : " _
        & Sommeranfang & iJahr & "  bis : " _
        & DateAdd("d", -1, Herbstanfang & iJahr) & " )"
        
    Case Is < Winteranfang & Right(datum, 4)
        fktJahreszeit = "Jahreszeit : Herbst ( von : " _
        & Herbstanfang & iJahr & "  bis : " _
        & DateAdd("d", -1, Winteranfang & iJahr) & " )"
        
    Case Is >= Winteranfang & Right(datum, 4)
        fktJahreszeit = "Jahreszeit : Winter ( von : " _
        & Winteranfang & iJahr & "  bis : " _
        & DateAdd("d", -1, Frhlingsanfang & iJahr + 1) & " )"
        
End Select
End Function

'MESZ Anfang Mitteleuropische Sommerzeit
Function MESZA(iJahr As Integer) As Date
On Error GoTo Fehlerbehandlung
Dim SZAnfang As Date
    SZAnfang = CDate("31.3." & iJahr)
       MESZA = SZAnfang - Weekday(SZAnfang) + 1
Exit Function
Fehlerbehandlung:
End Function

'MESZ Ende Mitteleuropische Sommerzeit
Function MESZE(iJahr As Integer) As Date
On Error GoTo Fehlerbehandlung
Dim SZEnde As Date
    SZEnde = CDate("31.10." & iJahr)
       MESZE = SZEnde - Weekday(SZEnde) + 1
Exit Function
Fehlerbehandlung:
End Function

Public Function fktSommerzeit(ByVal Jahr As Integer) As String
On Error GoTo Fehlerbehandlung
'den Beginn und das Ende der Sommerzeit anzeigen
fktSommerzeit = "Sommerzeit :  von  " _
    & Format(MESZA(Jahr), "ddd dd.mm.yyyy") _
    & "  bis  " & Format(MESZE(Jahr), "ddd dd.mm.yyyy")
Exit Function
Fehlerbehandlung:
End Function

Public Function fktTageJahr(ByVal datum As Date) As Integer
    'die Tage des entsprechenden Jahres ausrechnen
    fktTageJahr = DateDiff("d", "01.01." & Format(datum, "yyyy"), _
    "31.12." & Format(datum, "yyyy")) + 1
End Function

Public Function fktKalenderWoche(ByVal datum As Date) As Integer
    'die aktuelle Kalenderwoche des entsprechenden Jahres ausrechnen
    fktKalenderWoche = DatePart("ww", datum, StartDayofWeek, StartWeekofYear)
End Function
