Attribute VB_Name = "mdlIsAcrobatInstalled"
Option Explicit

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" _
                                    Alias "RegOpenKeyExA" _
                                    (ByVal hkey As Long, _
                                    ByVal lpSubKey As String, _
                                    ByVal ulOptions As Long, _
                                    ByVal samDesired As Long, _
                                    phkResult As Long) _
                                    As Long
                                    
Private Declare Function RegQueryValueEx Lib "advapi32.dll" _
                                    Alias "RegQueryValueExA" _
                                    (ByVal hkey As Long, _
                                    ByVal lpValueName As String, _
                                    ByVal lpReserved As Long, _
                                    lpType As Long, _
                                    lpData As Any, _
                                    lpcbData As Long) _
                                    As Long
                                    
Private Declare Function RegCloseKey Lib "advapi32.dll" _
                                    (ByVal hkey As Long) _
                                    As Long

Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const SYNCHRONIZE = &H100000

Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or _
                                 KEY_QUERY_VALUE Or _
                                 KEY_SET_VALUE Or _
                                 KEY_CREATE_SUB_KEY Or _
                                 KEY_ENUMERATE_SUB_KEYS Or _
                                 KEY_NOTIFY Or _
                                 KEY_CREATE_LINK) And (Not SYNCHRONIZE))
                                 
Private Const ERROR_SUCCESS = 0&
Private Const REG_SZ = 1

Public Const HKEY_LOCAL_MACHINE = &H80000002

Private Declare Function FindFirstFile Lib "kernel32" _
                                    Alias "FindFirstFileA" _
                                    (ByVal lpFileName As String, _
                                    lpFindFileData As WIN32_FIND_DATA) _
                                    As Long
                                    
Private Declare Function FindClose Lib "kernel32" _
                                    (ByVal hFindFile As Long) _
                                    As Long

Private Type FILETIME
    dwLowDateTime           As Long
    dwHighDateTime          As Long
End Type

Private Const MAX_PATH = 260

Private Type WIN32_FIND_DATA
    dwFileAttributes        As Long
    ftCreationTime          As FILETIME
    ftLastAccessTime        As FILETIME
    ftLastWriteTime         As FILETIME
    nFileSizeHigh           As Long
    nFileSizeLow            As Long
    dwReserved0             As Long
    dwReserved1             As Long
    cFileName               As String * MAX_PATH
    cAlternate              As String * 14
End Type

Dim lrt As Long
Private Const INVALID_HANDLE_VALUE = -1

Public Function QueryValue(ByVal hkey As Long, ByVal SubKey As String, ByVal ValueName As String) As String
    Dim Result      As String
    Dim phkResult   As Long
    Dim lpType      As Long
    Dim lpcbData    As Long
    Dim lRet        As Long
    
    Result = vbNullString
    lRet = RegOpenKeyEx(hkey, SubKey, 0&, KEY_ALL_ACCESS, phkResult)
    If lRet <> ERROR_SUCCESS Then GoTo SetResult
    lpcbData = 256
    Dim szData As String
    szData = String$(lpcbData, 0)
    lRet = RegQueryValueEx(phkResult, ValueName, 0&, lpType, ByVal szData, lpcbData)
    If lrt = ERROR_SUCCESS And lpType = REG_SZ Then
        lpcbData = lpcbData - 1
        Result = Left$(szData, lpcbData)
    Else
        Result = "Requiered information not found...."
    End If
    If hkey = 0 Then lRet = RegCloseKey(phkResult)
SetResult:
    QueryValue = Result
End Function

Public Function FileExist(ByVal Filename As String) As Boolean
    Dim fd              As WIN32_FIND_DATA
    Dim SearchHandle    As Long
    
    SearchHandle = FindFirstFile(Filename, fd)
    FileExist = SearchHandle <> INVALID_HANDLE_VALUE
    Call FindClose(SearchHandle)
End Function


