Attribute VB_Name = "mdlMSGEdit"
Option Explicit

' Bentigte API's fr die Timer-Steuerung
Public Declare Function SetTimer Lib "user32" ( _
  ByVal hwnd As Long, _
  ByVal nIDEvent As Long, _
  ByVal uElapse As Long, _
  ByVal lpTimer As Long) As Long

Public Declare Function KillTimer Lib "user32" ( _
  ByVal hwnd As Long, _
  ByVal nIDEvent As Long) As Long

Public Const MY_NID = 88
Public Const MY_ELAPSE = 25 ' Wartezeit: 25 MSek.

' Bentigte API's fr das Manipulieren der MsgBox
Public Declare Function MessageBox Lib "user32" _
  Alias "MessageBoxA" ( _
  ByVal hwnd As Long, _
  ByVal lpText As String, _
  ByVal lpCaption As String, _
  ByVal wType As Long) As Long

Public Declare Function GetActiveWindow _
  Lib "user32" () As Long

Public Declare Function SendDlgItemMessage Lib "USER32.DLL" _
  Alias "SendDlgItemMessageA" ( _
  ByVal hDlg As Long, _
  ByVal nIDDlgItem As Long, _
  ByVal wMsg As Long, _
  ByVal wParam As Long, _
  ByVal LParam As String) As Long

' Bentigte Konstanten
Public Const WM_SETTEXT = &HC

' MsgBox-Bildsymbole
Public Enum CoolBoxIcon
  Critical = 16
  Question = 32
  Exclamation = 48
  Information = 64
End Enum

' Variablen zur Speicherung der gewnschten
' Buttonbeschriftung
Private m_Caption1 As String
Private m_Caption2 As String
Private m_Caption3 As String

' WindowHandle
Private m_hWnd As Long

' MsgBox anzeigen
Public Function CoolBox(ByVal hwnd As Long, _
  ByVal Text As String, _
  ByVal Title As String, _
  ByVal Button1 As String, _
  Optional ByVal Button2 As String, _
  Optional ByVal Button3 As String, _
  Optional ByVal Symbol As CoolBoxIcon) As Long

  Dim nResult As Long
  
  ' Fensterhandle
  m_hWnd = hwnd

  ' Beschriftung der Buttons
  m_Caption1 = Button1
  m_Caption2 = Button2
  m_Caption3 = Button3

  ' API-Timer starten
  nResult = SetTimer(m_hWnd, MY_NID, MY_ELAPSE, _
    AddressOf Coolbox_TimerEvent)

  ' API Message-Box mit gewnschter Buttonalzahl aufrufen
  If Button2 = "" And Button3 = "" Then
    'Ein Button
    nResult = MessageBox(m_hWnd, Text, Title, _
      Symbol Or vbOKOnly)

  ElseIf Button2 <> "" And Button3 = "" Then
    ' Zwei Buttons
    nResult = MessageBox(m_hWnd, Text, Title, _
      Symbol Or vbYesNo)

  Else
    ' Drei Buttons
    nResult = MessageBox(m_hWnd, Text, Title, _
      Symbol Or vbAbortRetryIgnore)
  End If

  ' Antwort auswerten und Rckgabewert festlegen
  If nResult = 1 Or nResult = 3 Or nResult = 6 Then
    ' erster Button wurde gedrckt
    CoolBox = 1

  ElseIf nResult = 4 Or nResult = 7 Then
    ' zweiter Button wurde gedrckt
    CoolBox = 2

  Else
    ' dritter Button wurde gedrckt
    CoolBox = 3
  End If
End Function

' Timer-Event!
Sub Coolbox_TimerEvent()
  Dim nWnd As Long
  
  ' API-Timer wieder deaktivieren
  KillTimer m_hWnd, MY_NID
  
  ' Fensterhandle der MsgBox
  nWnd = GetActiveWindow()

  ' Buttons neu beschriften
  If m_Caption2 = "" And m_Caption3 = "" Then
    ' nur ein Button
    SendDlgItemMessage nWnd, vbCancel, WM_SETTEXT, 0, m_Caption1

  ElseIf m_Caption2 <> "" And m_Caption3 = "" Then
    ' Zwei Buttons
    SendDlgItemMessage nWnd, vbYes, WM_SETTEXT, 0, m_Caption1
    SendDlgItemMessage nWnd, vbNo, WM_SETTEXT, 0, m_Caption2

  Else
    ' Drei Buttons
    SendDlgItemMessage nWnd, vbAbort, WM_SETTEXT, 0, m_Caption1
    SendDlgItemMessage nWnd, vbRetry, WM_SETTEXT, 0, m_Caption2
    SendDlgItemMessage nWnd, vbIgnore, WM_SETTEXT, 0, m_Caption3
  End If
End Sub
