Attribute VB_Name = "mdlMenSound"
Option Explicit

Private Declare Function CallWindowProc Lib "user32" _
                         Alias "CallWindowProcA" ( _
                         ByVal lpPrevWndFunc As Long, _
                         ByVal hwnd As Long, _
                         ByVal msg As Long, _
                         ByVal wparam As Long, _
                         ByVal lparam As Long) As Long

Private Declare Function SetWindowLong Lib "user32" _
                         Alias "SetWindowLongA" ( _
                         ByVal hwnd As Long, _
                         ByVal nIndex As Long, _
                         ByVal dwNewLong As Long) As Long
                         
Private Const GWL_WNDPROC = (-4)
Private Const WM_MENUSELECT = &H11F
Private Const MF_SEPARATOR = &H800&
Private Const MF_DISABLED = &H2&
Private Const MF_ENABLED = &H0&
Private Const MF_GRAYED = &H1&

Private Declare Function GetSysColor Lib "USER32.DLL" (ByVal nIndex As Long) As Long

Private OldWndProc As Long

'Geschrieben von Wolfgang Ehrhardt
'                   woeh@gmx.de
   
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long

Public Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long

Public Declare Function DrawMenuBar Lib "user32" _
    (ByVal hwnd As Long) As Long

Private Declare Function SetMenuInfo Lib "user32" _
    (ByVal hMenu As Long, Mi As MENUINFO) As Long

Private Declare Function OleTranslateColor Lib "olepro32.dll" _
    (ByVal OLE_COLOR As Long, ByVal hPalette As Long, _
    pccolorref As Long) As Long

Public Declare Function GetSystemMenu Lib "user32" _
    (ByVal hwnd As Long, ByVal bRevert As Long) As Long

Private Declare Function GetMenuItemCountA Lib "user32" Alias _
    "GetMenuItemCount" (ByVal hMenu As Long) As Long

Public Declare Function GetSubMenu Lib "user32" _
    (ByVal hMenu As Long, ByVal nPos As Long) As Long
    
Private Declare Function GetMenuState Lib "USER32.DLL" _
(ByVal hMenu As Long, ByVal wID As Long, ByVal wFlags As Long) As Long

Public Declare Function DeleteMenu Lib "user32" ( _
  ByVal hMenu As Long, _
  ByVal nPosition As Long, _
  ByVal wFlags As Long) As Long

Private Type MENUINFO
    cbSize          As Long
    fMask           As Long
    dwStyle         As Long
    cyMax           As Long
    hbrBack         As Long
    dwContextHelpID As Long
    dwMenuData      As Long
End Type

Public Enum MenuNFO
    mMenuBarColor = 1
    mMenuColor = 2
    mSysMenuColor = 3
End Enum

Public Declare Function LoadImage Lib "user32" Alias "LoadImageA" _
(ByVal hinst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, _
ByVal n2 As Long, ByVal un2 As Long) As Long

Public Declare Function GetMenuItemID Lib "user32" _
(ByVal hMenu As Long, ByVal nPos As Long) As Long

Public Declare Function SetMenuItemBitmaps Lib "user32" _
(ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, _
ByVal hBitmapUnchecked As Long, ByVal hBitmapChecked As Long) As Long

Public Const MF_BITMAP = &H4&
Public Const LR_LOADFROMFILE = &H10
Public Const IMAGE_BITMAP = 0

Private Const MIM_BACKGROUND As Long = &H2&
Private Const MIM_APPLYTOSUBMENUS As Long = &H80000000

Public Const m_def_MenuColor = &HEBD3C5
Public Const m_def_SubMenuColor = &HEBD3C5
Public Const m_def_SysMenuColor = &HEBD3C5

Public MenuColor As OLE_COLOR
Public SubMenuColor As OLE_COLOR
Public SysMenuColor As OLE_COLOR

Public Const m_def_ShowDokumente = False
Public ShowDokumente As Boolean

Public Const m_def_TBStyle = 1  'Office 2003
Public TBStyle As Long

Public Const m_def_WidhtTrvDokumente = 2500  'default VerticalMenu
Public WidhtTrvDokumente As Long

Public Enum eMenubmps
    eLschen = 0
    effnen = 1
    eSpeichern = 2
    eSchlieen = 3
    eDrucken = 4
    eAppSchlieen = 5
    eSuchen = 6
    eNeu = 7
    eTabelle = 8
    eHintergrund = 9
    eRckgngig = 10
    eWiederherstellen = 11
    eAusschneiden = 12
    eKopieren = 13
    eEinfgen = 14
    eGrafikeinfgen = 15
    eKalender = 16
    eUhrzeit = 17
    eEditor = 18
    eZoom = 19
    eTip = 20
    eSound = 21
    eLotto = 22
    ePDF = 23
    eRegistrierung = 24
    eAutorun = 25
    eBearbeiten = 26
    eABC = 27
    eRechtschreibprfung = 28
    eSonderzeichen = 29
    eTab = 30
    eSerienbrief = 31
    eVerschlsseln = 32
    eEntschlsseln = 33
    eKennwort = 34
    eKennworthinweis = 35
    eFensterschlieen = 36
    eUmlaute = 37
    eBuchstabensortieren = 38
    eZahlensortieren = 39
    eBildbetrachter = 40
    eGeburtstage = 41
    eVorschau = 42
    eDruckbereich = 43
End Enum

'Den halter des Bitmaphandles
Public BitmapsMen(44) As Long
'fr das freimachen des Speichers
Private Const maxMenBitmaps = 44

Public Sub MenBitmapsladen()
    
    If IsFilePath(Laufwerk & "Delete.bmp") Then
        BitmapsMen(eMenubmps.eLschen) = LoadImage(App.hInstance, Laufwerk & "Delete.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Open.bmp") Then
        BitmapsMen(eMenubmps.effnen) = LoadImage(App.hInstance, Laufwerk & "Open.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Save.bmp") Then
        BitmapsMen(eMenubmps.eSpeichern) = LoadImage(App.hInstance, Laufwerk & "Save.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Schlieen.bmp") Then
        BitmapsMen(eMenubmps.eSchlieen) = LoadImage(App.hInstance, Laufwerk & "Schlieen.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Print.bmp") Then
        BitmapsMen(eMenubmps.eDrucken) = LoadImage(App.hInstance, Laufwerk & "Print.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Close.bmp") Then
        BitmapsMen(eMenubmps.eAppSchlieen) = LoadImage(App.hInstance, Laufwerk & "Close.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Find.bmp") Then
        BitmapsMen(eMenubmps.eSuchen) = LoadImage(App.hInstance, Laufwerk & "Find.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "New.bmp") Then
        BitmapsMen(eMenubmps.eNeu) = LoadImage(App.hInstance, Laufwerk & "New.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "View.bmp") Then
        BitmapsMen(eMenubmps.eTabelle) = LoadImage(App.hInstance, Laufwerk & "View.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Background.bmp") Then
        BitmapsMen(eMenubmps.eHintergrund) = LoadImage(App.hInstance, Laufwerk & "Background.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Undo.bmp") Then
        BitmapsMen(eMenubmps.eRckgngig) = LoadImage(App.hInstance, Laufwerk & "Undo.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Redo.bmp") Then
        BitmapsMen(eMenubmps.eWiederherstellen) = LoadImage(App.hInstance, Laufwerk & "Redo.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Cut.bmp") Then
        BitmapsMen(eMenubmps.eAusschneiden) = LoadImage(App.hInstance, Laufwerk & "Cut.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Copy.bmp") Then
        BitmapsMen(eMenubmps.eKopieren) = LoadImage(App.hInstance, Laufwerk & "Copy.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Paste.bmp") Then
        BitmapsMen(eMenubmps.eEinfgen) = LoadImage(App.hInstance, Laufwerk & "Paste.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Grafik.bmp") Then
        BitmapsMen(eMenubmps.eGrafikeinfgen) = LoadImage(App.hInstance, Laufwerk & "Grafik.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Kalender.bmp") Then
        BitmapsMen(eMenubmps.eKalender) = LoadImage(App.hInstance, Laufwerk & "Kalender.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Uhrzeit.bmp") Then
        BitmapsMen(eMenubmps.eUhrzeit) = LoadImage(App.hInstance, Laufwerk & "Uhrzeit.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Editor.bmp") Then
        BitmapsMen(eMenubmps.eEditor) = LoadImage(App.hInstance, Laufwerk & "Editor.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Zoom.bmp") Then
        BitmapsMen(eMenubmps.eZoom) = LoadImage(App.hInstance, Laufwerk & "Zoom.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Tip.bmp") Then
        BitmapsMen(eMenubmps.eTip) = LoadImage(App.hInstance, Laufwerk & "Tip.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Volume.bmp") Then
        BitmapsMen(eMenubmps.eSound) = LoadImage(App.hInstance, Laufwerk & "Volume.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Lotto.bmp") Then
        BitmapsMen(eMenubmps.eLotto) = LoadImage(App.hInstance, Laufwerk & "Lotto.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "PDF.bmp") Then
        BitmapsMen(eMenubmps.ePDF) = LoadImage(App.hInstance, Laufwerk & "PDF.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Registrierung.bmp") Then
        BitmapsMen(eMenubmps.eRegistrierung) = LoadImage(App.hInstance, Laufwerk & "Registrierung.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Mycomp.bmp") Then
        BitmapsMen(eMenubmps.eAutorun) = LoadImage(App.hInstance, Laufwerk & "Mycomp.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Bearbeiten.bmp") Then
        BitmapsMen(eMenubmps.eBearbeiten) = LoadImage(App.hInstance, Laufwerk & "Bearbeiten.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "SMALLCAP.bmp") Then
        BitmapsMen(eMenubmps.eABC) = LoadImage(App.hInstance, Laufwerk & "SMALLCAP.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "SPELLING.bmp") Then
        BitmapsMen(eMenubmps.eRechtschreibprfung) = LoadImage(App.hInstance, Laufwerk & "SPELLING.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Sonderzeichen.bmp") Then
        BitmapsMen(eMenubmps.eSonderzeichen) = LoadImage(App.hInstance, Laufwerk & "Sonderzeichen.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Tab.bmp") Then
        BitmapsMen(eMenubmps.eTab) = LoadImage(App.hInstance, Laufwerk & "Tab.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Serienbrief.bmp") Then
        BitmapsMen(eMenubmps.eSerienbrief) = LoadImage(App.hInstance, Laufwerk & "Serienbrief.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "lock16.bmp") Then
        BitmapsMen(eMenubmps.eVerschlsseln) = LoadImage(App.hInstance, Laufwerk & "lock16.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "unlock16.bmp") Then
        BitmapsMen(eMenubmps.eEntschlsseln) = LoadImage(App.hInstance, Laufwerk & "unlock16.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Schlssel.bmp") Then
        BitmapsMen(eMenubmps.eKennwort) = LoadImage(App.hInstance, Laufwerk & "Schlssel.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Help.bmp") Then
        BitmapsMen(eMenubmps.eKennworthinweis) = LoadImage(App.hInstance, Laufwerk & "Help.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Wndclose.bmp") Then
        BitmapsMen(eMenubmps.eFensterschlieen) = LoadImage(App.hInstance, Laufwerk & "Wndclose.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Umlaut.bmp") Then
        BitmapsMen(eMenubmps.eUmlaute) = LoadImage(App.hInstance, Laufwerk & "Umlaut.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "SortA.bmp") Then
        BitmapsMen(eMenubmps.eBuchstabensortieren) = LoadImage(App.hInstance, Laufwerk & "SortA.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "SortZ.bmp") Then
        BitmapsMen(eMenubmps.eZahlensortieren) = LoadImage(App.hInstance, Laufwerk & "SortZ.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Bildbetrachter.bmp") Then
        BitmapsMen(eMenubmps.eBildbetrachter) = LoadImage(App.hInstance, Laufwerk & "Bildbetrachter.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "People.bmp") Then
        BitmapsMen(eMenubmps.eGeburtstage) = LoadImage(App.hInstance, Laufwerk & "People.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Preview.bmp") Then
        BitmapsMen(eMenubmps.eVorschau) = LoadImage(App.hInstance, Laufwerk & "Preview.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If
    If IsFilePath(Laufwerk & "Druckbereich.bmp") Then
        BitmapsMen(eMenubmps.eDruckbereich) = LoadImage(App.hInstance, Laufwerk & "Druckbereich.bmp", IMAGE_BITMAP, 13, 13, LR_LOADFROMFILE)
    End If

End Sub

Public Sub BitmapsMenLschen()
For i = 0 To maxMenBitmaps
    DeleteObject (BitmapsMen(i))
Next
End Sub

'*** Dokumentation der Funktion ***
'Beschreibung
    'Frbt ein angegebenes MenuElement in eine angegebene Farbe ein.

'Rckgabewert
'True wenn MenuElement erfolgreich eingefrbt wurde

'bergabewert(e)
'[SetWhat As MenuNFO]
    'mMenuBarColor
        'Frbt die MenuBar
        'MenuIndex & IncludeSubmenus kann weggelaen werden
    'mMenuColor
        'Frbt einen Menueintrag mit/ohne Untermenueintrge
    'mSysMenuColor
        'Frbt das SystemMenu
        'MenuIndex & IncludeSubmenus kann weggelaen werden
'Hwnd
    'Verweis auf das Hwnd des Menu-Owners
'Color
    'Farbe, in die eingefrbt werden soll
'Optional MenuIndex As Integer
    'Nur gltig bei mMenucolor
    'Einzufrbendes MenuElement
'Optional IncludeSubmenus As Boolean = False
    'Nur gltig bei mMenucolor
    'Wird True angegeben und hat das Menuelement eine Untermenu,
    'so wird dieses mitgefrbt.

Public Function Set_MenuColor(SetWhat As MenuNFO, _
    ByVal hwnd As Long, ByVal Color As Long, _
    Optional MenuIndex As Integer, _
    Optional IncludeSubmenus As Boolean = False) As Boolean
    
    Dim Mi As MENUINFO
    Dim clrref As Long, hSysMenu As Long, mHwnd As Long
         
    On Local Error GoTo Quit
   
    clrref = Convert_OLEtoRBG(Color)
   
    Mi.cbSize = Len(Mi)
    Mi.hbrBack = CreateSolidBrush(clrref)
    
    Select Case SetWhat
        Case mMenuBarColor
            Mi.fMask = MIM_BACKGROUND
            Call SetMenuInfo(GetMenu(hwnd), Mi)
            
        Case mMenuColor
            If MenuIndex = 0 Then
                Set_MenuColor = Set_MenuColor(mMenuBarColor, hwnd, Color)
                Exit Function
            End If
            
            If MenuIndex < 1 Or Get_MenuItemCount(hwnd) < MenuIndex Then _
                Exit Function
    
            Mi.fMask = IIf(IncludeSubmenus, _
                           MIM_BACKGROUND Or MIM_APPLYTOSUBMENUS, _
                           MIM_BACKGROUND)
            
            mHwnd = GetMenu(hwnd)
            mHwnd = GetSubMenu(mHwnd, MenuIndex - 1)
        
            Call SetMenuInfo(mHwnd, Mi)
            hwnd = mHwnd
            
        Case mSysMenuColor
            hSysMenu = GetSystemMenu(hwnd, False)
   
            Mi.fMask = MIM_BACKGROUND _
                       Or MIM_APPLYTOSUBMENUS
            
            Call SetMenuInfo(hSysMenu, Mi)
            hwnd = hSysMenu
    End Select
    
    Call DrawMenuBar(hwnd)
    Set_MenuColor = True
Quit:
End Function

Private Function Convert_OLEtoRBG(ByVal OLEcolor As Long) As Long
    Call OleTranslateColor(OLEcolor, 0, Convert_OLEtoRBG)
End Function

Private Function Get_MenuItemCount(ByVal hwnd As Long) As Long
    Get_MenuItemCount = GetMenuItemCountA(Get_MenuHwnd(hwnd))
End Function

Private Function Get_MenuHwnd(ByVal hwnd As Long) As Long
    Get_MenuHwnd = GetMenu(hwnd)
End Function

' Subclassing starten
Public Sub MenuSubclassStart(ByVal hwnd As Long)
      
      OldWndProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf NewWindowProc)
End Sub

' Subclassing beenden
Public Sub MenuSubclassEnd(ByVal hwnd As Long)
      
      SetWindowLong hwnd, GWL_WNDPROC, OldWndProc
End Sub

' Windows-Message abfangen
Private Function NewWindowProc(ByVal hwnd As Long, _
                               ByVal uMsg As Long, _
                               ByVal wparam As Long, _
                               ByVal lparam As Long) As Long

   Dim hMenu As Long
   Dim MenuItemId As Long, PopUpID As Long
      
      'Balken wird auf Men bewegt
      If uMsg = WM_MENUSELECT Then
         'Handle des Mens ermitteln:
         hMenu = lparam
         'Men-ID des Menpunkts ermitteln
         MenuItemId = wparam And &HFFFF&
         PopUpID = wparam And &H10FFFF
         
        'prfen ob Menu ein Separator oder Disabled ist
        If (GetMenuState(GetMenu(hwnd), MenuItemId, 0) And MF_SEPARATOR) = _
            MF_SEPARATOR Or (GetMenuState(GetMenu(hwnd), MenuItemId, 0) And MF_DISABLED) = _
            MF_DISABLED Then
            'wenn Separator oder disabled dann keinen Sound abspielen
        Else
                'Men-Sound abspielen
                 Call PlayMenuSound
        End If
        
        If (GetMenuState(GetMenu(hwnd), PopUpID, 0) And MF_SEPARATOR) = _
            MF_SEPARATOR Or (GetMenuState(GetMenu(hwnd), PopUpID, 0) And MF_DISABLED) = _
            MF_DISABLED Then
            'wenn Separator oder disabled dann keinen Sound abspielen
        Else
                'Men-Sound abspielen
                 Call PlayMenuSound
        End If
      End If
         
      ' Nachricht an die ursprngliche Fensterprozedur weiterleiten
      NewWindowProc = CallWindowProc(OldWndProc, hwnd, uMsg, _
                                     wparam, ByVal lparam)
End Function

' Speichern
Public Sub AppMenuProperties_Save()
On Error GoTo Fehlerbehandlung

Dim fso As New FileSystemObject
Dim dR As Drive
Dim drLaufwerksbuchstabe As String
Dim drLaufwerk As String

'fr dr (Laufwerk) sind die ersten 2 Zeichen wichtig und mssen ermittelt werden
drLaufwerksbuchstabe = Left(Laufwerk, 2)

'bei nicht betriebsbereitem Laufwerk
On Error Resume Next

For Each dR In fso.Drives
    'Laufwerksbuchstaben einsetzen
    'den Laufwerkstyp ermitteln
    If dR = drLaufwerksbuchstabe Then
        Select Case dR.DriveType
            Case Is = CDRom
                drLaufwerk = "CD-Rom"
            Case Is = Fixed
                drLaufwerk = "Festplatte"
            Case Is = RamDisk
                drLaufwerk = "Ram-Disk"
            Case Is = Remote
                drLaufwerk = "Netzlaufwerk"
            Case Is = Removable
                drLaufwerk = "Wechseldatentrger"
            Case Else
                drLaufwerk = "Unbekannt"
        End Select
    'wenn gefunden Schleife verlassen
    Exit For
    End If
Next

If dR.DriveType <> CDRom Then

  Dim f As Integer

  ' Neues PropertyBag-Objekt erstellen
  Dim myPropBag As New PropertyBag

  With myPropBag
'******************************************************************************
    'die Werte speichern um die Farben _
    nicht jedesmal einstellen zu mssen
    .WriteProperty "MenuColor", MenuColor, m_def_MenuColor
    .WriteProperty "SubMenuColor", SubMenuColor, m_def_SubMenuColor
    .WriteProperty "SysMenuColor", SysMenuColor, m_def_SysMenuColor
    .WriteProperty "WidhtTrvDokumente", WidhtTrvDokumente, m_def_WidhtTrvDokumente
    .WriteProperty "TBStyle", TBStyle, m_def_TBStyle
    .WriteProperty "ShowDokumente", ShowDokumente, m_def_ShowDokumente
'******************************************************************************
  End With

  ' Jetzt den Inhalt des PropertyBags speichern
  ' Falls die Datei existiert - vorher lschen!
    If IsFilePath(Laufwerk & "AppMenuColor.dat") Then _
        Kill Laufwerk & "AppMenuColor.dat"

        f = FreeFile
        Open Laufwerk & "AppMenuColor.dat" For Binary As #f
        Put #f, , myPropBag.Contents
        Close #f
End If

    Set fso = Nothing
    Set dR = Nothing

Exit Sub
Fehlerbehandlung:
Set fso = Nothing
Set dR = Nothing
    
Screen.MousePointer = vbDefault
Call Fehlermeldung
End Sub

' Lesen
Public Sub AppMenuProperties_Load()
On Error GoTo Fehlerbehandlung

  Dim f As Integer
  Dim vInhalt As Variant

  ' Neues PropertyBag-Objekt erstellen
  Dim myPropBag As New PropertyBag
  
  'prfen ob Datei existiert
  If IsFilePath(Laufwerk & "AppMenuColor.dat") Then
  ' Datei-Inhalt einlesen
    f = FreeFile
    Open Laufwerk & "AppMenuColor.dat" For Binary As #f
    Get #f, , vInhalt
    Close #f

    ' Inhalt dem PropertyBag-Objekt zuweisen
    myPropBag.Contents = vInhalt

    With myPropBag
'******************************************************************************
    'die Werte laden
    MenuColor = .ReadProperty("MenuColor", m_def_MenuColor)
    SubMenuColor = .ReadProperty("SubMenuColor", m_def_SubMenuColor)
    SysMenuColor = .ReadProperty("SysMenuColor", m_def_SysMenuColor)
    WidhtTrvDokumente = .ReadProperty("WidhtTrvDokumente", m_def_WidhtTrvDokumente)
    TBStyle = .ReadProperty("TBStyle", m_def_TBStyle)
    ShowDokumente = .ReadProperty("ShowDokumente", m_def_ShowDokumente)
'******************************************************************************
    
    'Umwandlen einer Systemfarbe nach RGB
    If (MenuColor And &HFF000000) = &H80000000 Then _
    MenuColor = GetSysColor(MenuColor And &HFFFFFF)
    
    'Umwandlen einer Systemfarbe nach RGB
    If (SubMenuColor And &HFF000000) = &H80000000 Then _
    SubMenuColor = GetSysColor(SubMenuColor And &HFFFFFF)
    
    'Umwandlen einer Systemfarbe nach RGB
    If (SysMenuColor And &HFF000000) = &H80000000 Then _
    SysMenuColor = GetSysColor(SysMenuColor And &HFFFFFF)

    End With
  Else  'Datei existiert nicht
    MenuColor = m_def_MenuColor
    SubMenuColor = m_def_MenuColor
    SysMenuColor = m_def_SysMenuColor
    
    'Umwandlen einer Systemfarbe nach RGB
    If (MenuColor And &HFF000000) = &H80000000 Then _
    MenuColor = GetSysColor(MenuColor And &HFFFFFF)
    
    'Umwandlen einer Systemfarbe nach RGB
    If (SubMenuColor And &HFF000000) = &H80000000 Then _
    SubMenuColor = GetSysColor(SubMenuColor And &HFFFFFF)
    
    'Umwandlen einer Systemfarbe nach RGB
    If (SysMenuColor And &HFF000000) = &H80000000 Then _
    SysMenuColor = GetSysColor(SysMenuColor And &HFFFFFF)

  End If

Exit Sub
Fehlerbehandlung:
    Close #f
    MenuColor = m_def_MenuColor
    SubMenuColor = m_def_MenuColor
    SysMenuColor = m_def_SysMenuColor
Call Fehlermeldung
End Sub
