Attribute VB_Name = "mdlPrintRTFMargin"
Option Explicit


'Print a Rich Text Box with Margins
'Author: Intelligent Solutions Inc. (Featured Developer)
'Category: Forms and Controls
'Type: Snippets
'Difficulty: Advanced
'
'
'Version Compatibility:  Visual Basic 5   Visual Basic 6
'
'
'More information: _
This function allows you to set margins when printing the contents of a rich text box. _
The margin parameters are set in inches. See comments for details.
'
'This code has been viewed 29826 times.
'
'Instructions: _
Copy the declarations and code below and paste directly into your VB project.
'
'
'Declarations:

Public Declare Function GetDeviceCaps Lib "gdi32" _
  (ByVal hdc As Long, ByVal nIndex As Long) As Long
Public Declare Function CreateDC Lib "gdi32" Alias _
        "CreateDCA" (ByVal lpDriverName As String, ByVal _
        lpDeviceName As String, ByVal lpOutput As Long, _
        ByVal lpInitData As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
(ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc _
        As Long) As Long
        
Public Const PHYSICALOFFSETX As Long = 112
Public Const PHYSICALOFFSETY As Long = 113
Public Const WM_USER As Long = &H400
Public Const EM_FORMATRANGE As Long = WM_USER + 57
Public Const EM_SETTARGETDEVICE As Long = WM_USER + 72
Public Const EM_SCROLLCARET As Long = &HB7
Public Const EM_SCROLL As Long = &HB5
Public Const EM_LINESCROLL As Long = &HB6
Public Const EM_GETLINECOUNT As Long = &HBA        '// Total Line Count
Public Const EM_LINEFROMCHAR As Long = &HC9
Public Const EM_GETFIRSTVISIBLELINE As Long = &HCE
Public Const EM_LINELENGTH As Long = &HC1
Public Const EM_LINEINDEX As Long = &HBB
Public Const EM_GETLINE = &HC4
Public Const EM_GETSEL = &HB0
Public Const CB_SELECTSTRING As Long = &H14D

Public Const WM_PASTE = &H302


Public Type RECT
      Left As Long
      Top As Long
      Right As Long
      Bottom As Long
End Type

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Type CharRange
  cpMin As Long
  cpMax As Long
End Type

Public Type FormatRange
  hdc As Long
  hdcTarget As Long
  rc As RECT
  rcPage As RECT
  chrg As CharRange
End Type

Public PrtDC As Long
Public ObererRand As Long
Public LinkerRand As Long
Public RechterRand As Long
Public UntererRand As Long

'Public Declare Function GetDeviceCaps Lib "gdi32" _
'   (ByVal hdc As Long, ByVal nIndex As Long) As Long
'
'Public Declare Function SendMessage Lib "USER32" _
'  Alias "SendMessageA" (ByVal hWnd As Long, ByVal msg As Long, _
'  ByVal wp As Long, lp As Any) As Long

'den Druckernamen in Variable speichern
Public Printername As String
'die nicht druckbare Abstnde des Druckers speichern
Public GrenzeLinkerRand As Long
Public GrenzeRechterRand As Long
Public GrenzeObererRand As Long
Public GrenzeUntererRand As Long

'die eingestellten Abstnde speichern
Public AbstandLinkerRand As Long
Public AbstandRechterRand As Long
Public AbstandObererRand As Long
Public AbstandUntererRand As Long

Public Drucken As Boolean
Public BreiteSeite As String
Public HheSeite As String
Public DruckAuftragSeiten As Integer
Public MSGResult As Long   'zum abfragen des Long-Werts der Messagebox

Public strPrintFile As String
Public strKopfzeile As String
Public strFuzeile As String

Public strPrinterFont As String
Public iPrinterFontSize As Long
Public bolPrinterFontBold As Boolean
Public bolPrinterFontItalic As Boolean
Public bolPrinterFontStrikethru As Boolean
Public bolPrinterFontUnderline As Boolean
'fr die entsprechende Druckoptionen (Hoch- bzw. Querformat)
Public PrinterOrientation As Integer

Public bolDruckeinstellungengendert As Boolean


'Some public variables for printer/screen formatting

   Public gLeft As Long
   Public gRight As Long
   Public gTop As Long
   Public gBottom As Long
   Public gHeader As String
   Public gFooter As String
   Public gAlign As Integer '0=left 1=center 2=right
   Public gHeadAlign As Integer '0=left 1=center 2=right - Alignment for header
   Public gFootAlign As Integer '0=left 1=center 2=right - Alignment for footer
   Public gPageNumber As Long 'counts printed pages
   Public gOrientation As Integer
   Public gPaperSize As Variant
   Public gPaperWidth As Variant
   Public gPaperHeight As Variant
   Public gMargin As Long
  
   Private Prs As String 'The parsed header/footer string
   
' Speichern
Public Sub AppDruckProperties_Save()
On Error GoTo Fehlerbehandlung
Dim drLaufwerksbuchstabe As String
Dim drLaufwerk As String
Dim fso As New FileSystemObject
Dim dR As Drive
'fr dr (Laufwerk) sind die ersten 2 Zeichen wichtig und mssen ermittelt werden
drLaufwerksbuchstabe = Left(Laufwerk, 2)

'bei nicht betriebsbereitem Laufwerk
On Error Resume Next

For Each dR In fso.Drives
    'Laufwerksbuchstaben einsetzen
    'den Laufwerkstyp ermitteln
    If dR = drLaufwerksbuchstabe Then
        Select Case dR.DriveType
            Case Is = CDRom
                drLaufwerk = "CD-Rom"
            Case Is = Fixed
                drLaufwerk = "Festplatte"
            Case Is = RamDisk
                drLaufwerk = "Ram-Disk"
            Case Is = Remote
                drLaufwerk = "Netzlaufwerk"
            Case Is = Removable
                drLaufwerk = "Wechseldatentrger"
            Case Else
                drLaufwerk = "Unbekannt"
        End Select
    'wenn gefunden Schleife verlassen
    Exit For
    End If
Next
        'drLaufwerk, der Laufwerkstyp ist nun ermittelt _
        und wird nun im mdlffentlicheVariablen gespeichert


If dR.DriveType <> CDRom Then
  Dim f As Integer

  ' Neues PropertyBag-Objekt erstellen
  Dim myPropBag As New PropertyBag

  ' Einstellungen zunchst im PropertyBag-Objekt speichern
  With myPropBag
'******************************************************************************
    .WriteProperty "AbstandRechterRand", AbstandRechterRand, GrenzeRechterRand
    .WriteProperty "AbstandLinkerRand", AbstandLinkerRand, GrenzeLinkerRand
    .WriteProperty "AbstandObererRand", AbstandObererRand, GrenzeObererRand
    .WriteProperty "AbstandUntererRand", AbstandUntererRand, GrenzeUntererRand
    .WriteProperty "strPrinterFont", strPrinterFont, "Courier New"
    .WriteProperty "iPrinterFontSize", iPrinterFontSize, 11
    .WriteProperty "bolPrinterFontBold", bolPrinterFontBold, False
    .WriteProperty "bolPrinterFontItalic", bolPrinterFontItalic, False
    .WriteProperty "bolPrinterFontStrikethru", bolPrinterFontStrikethru, False
    .WriteProperty "bolPrinterFontUnderline", bolPrinterFontUnderline, False
'******************************************************************************
  End With

  ' Jetzt den Inhalt des PropertyBags speichern
  ' Falls die Datei existiert - vorher lschen!
  If Dir$(Laufwerk & "AppProperties_Druck.dat", vbNormal) <> "" Then _
    Kill Laufwerk & "AppProperties_Druck.dat"

  f = FreeFile
  Open Laufwerk & "AppProperties_Druck.dat" For Binary As #f
  Put #f, , myPropBag.Contents
  Close #f
  
  bolDruckeinstellungengendert = False
End If

    Set fso = Nothing
    Set dR = Nothing
    
Exit Sub
Fehlerbehandlung:

    Set fso = Nothing
    Set dR = Nothing
    
Call Fehlermeldung
End Sub

' Lesen
Public Sub AppDruckProperties_Load()
On Error GoTo Fehlerbehandlung
    On Error Resume Next
  Dim f As Integer
  Dim vInhalt As Variant

  ' Neues PropertyBag-Objekt erstellen
  Dim myPropBag As New PropertyBag

  ' Datei-Inhalt einlesen
  If Dir$(Laufwerk & "AppProperties_Druck.dat", vbNormal) <> "" Then
    f = FreeFile
    Open Laufwerk & "AppProperties_Druck.dat" For Binary As #f
    Get #f, , vInhalt
    Close #f

    ' Inhalt dem PropertyBag-Objekt zuweisen
    myPropBag.Contents = vInhalt

    ' Einstellungen den Controls zuweisen
    With myPropBag
    '******************************************************************************
        'bei bedarf die entsprechenden Werte aus der Registry lesen
        'die Farbwerte mit der GetSetting-Methode einlesen
        AbstandRechterRand = .ReadProperty("AbstandRechterRand", GrenzeRechterRand)
        AbstandLinkerRand = .ReadProperty("AbstandLinkerRand", GrenzeLinkerRand)
        AbstandObererRand = .ReadProperty("AbstandObererRand", GrenzeObererRand)
        AbstandUntererRand = .ReadProperty("AbstandUntererRand", GrenzeUntererRand)
        strPrinterFont = .ReadProperty("strPrinterFont", "Courier New")
        iPrinterFontSize = .ReadProperty("iPrinterFontSize", 11)
        bolPrinterFontBold = .ReadProperty("bolPrinterFontBold", False)
        bolPrinterFontItalic = .ReadProperty("bolPrinterFontItalic", False)
        bolPrinterFontStrikethru = .ReadProperty("bolPrinterFontStrikethru", False)
        bolPrinterFontUnderline = .ReadProperty("bolPrinterFontUnderline", False)
    '******************************************************************************
    End With
  End If
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

'Die Funktion prft, ob ein Drucker vorhanden ist und
'gibt im Erfolgsfall True, andernfalls False zurck
Public Function CheckForPrinter() As Boolean
  Dim sName As String

  On Local Error Resume Next
  sName = Printer.DeviceName
  CheckForPrinter = (Err = 0)
  On Local Error GoTo 0
End Function

' Ermitteln der nichtbedruckbaren Rnder
Public Sub GetPhysicalPageSize(Printer As Object, _
  pLeft As Long, pTop As Long, _
  Optional pWidth As Long, Optional pHeight As Long, _
  Optional pRight As Long, Optional pBottom As Long, _
  Optional ByVal ScaleMode As Integer = vbMillimeters)

  Const PHYSICALWIDTH = 110
  Const PHYSICALHEIGHT = 111
  Const PHYSICALOFFSETX = 112
  Const PHYSICALOFFSETY = 113

  With Printer
    ' Papiergre
    pWidth = .ScaleX(GetDeviceCaps(.hdc, _
      PHYSICALWIDTH), vbPixels, ScaleMode)
    pHeight = .ScaleY(GetDeviceCaps(.hdc, _
      PHYSICALHEIGHT), vbPixels, ScaleMode)
  
    ' nicht bedruckbare Rnder: Links und Oben
    pLeft = .ScaleX(GetDeviceCaps(.hdc, _
      PHYSICALOFFSETX), vbPixels, ScaleMode)
    pTop = .ScaleY(GetDeviceCaps(.hdc, _
      PHYSICALOFFSETY), vbPixels, ScaleMode)
      
    ' nicht bedruckbare Rnder: Rechts und unten
    pRight = pWidth - pLeft - _
      .ScaleX(.ScaleWidth, .ScaleMode, ScaleMode)
    pBottom = pHeight - pTop - _
      .ScaleY(.ScaleHeight, .ScaleMode, ScaleMode)
  End With
End Sub

Public Sub SeitenDruckRandPrfen()

  Dim pLeft As Long
  Dim pTop As Long
  Dim pRight As Long
  Dim pBottom As Long
  Dim pWidth As Long
  Dim pHeight As Long
  Dim sMsg As String

'Die nachfolgende Prozedur ermittelt fr das im ersten Parameter _
angegeben Druckerobjekt folgende Rand- und Papier-Einstellungen:
'
'pLeft: nichbedruckbarere Rand "links"
'pTop: nichtbedruckbarer Rand "oben"
'pWidth: Papierbreite insgesamt
'pHeight: Papiergre insgesamt
'pRight: nichtbedruckbarer Rand "rechts"
'pBottom: nichtbedruckbarer Rand "unten"

'In welcher Maeinheit die Ergebnisse zurckgeliefert werden sollen _
legen Sie im letzten Parameter fest:

'vbTwips (1)
'vbPoints (2)
'vbPixels (3)
'vbInches (5)
'vbMillimeters (6)
'vbCentimeters (7)

  ' Einstellungen des Standard-Druckers
  GetPhysicalPageSize Printer, pLeft, pTop, _
    pWidth, pHeight, pRight, pBottom, vbMillimeters
  
  Printername = Printer.DeviceName
  BreiteSeite = CStr(pWidth) & " mm"
  HheSeite = CStr(pHeight) & " mm"
  GrenzeLinkerRand = pLeft
  GrenzeRechterRand = pRight
  GrenzeObererRand = pTop
  GrenzeUntererRand = pBottom
End Sub

Public Sub PrintRTFWithMargins(RTFControl As Object, _
   ByVal LeftMargin As Single, ByVal TopMargin As Single, _
   ByVal RightMargin As Single, ByVal BottomMargin As Single)
   
'********************************************************8
'PURPOSE: Prints Contents of RTF Control with Margins

'PARAMETERS:
    'RTFControl: RichTextBox Control For Printing
    'LeftMargin: Left Margin in Inches
    'TopMargin: TopMargin in Inches
    'RightMargin: RightMargin in Inches
    'BottomMargin: BottomMargin in Inches

'***************************************************************

On Error GoTo ErrorHandler


'*************************************************************
'I DO THIS BECAUSE IT IS MY UNDERSTANDING THAT
'WHEN CALLING A SERVER DLL, YOU CAN RUN INTO
'PROBLEMS WHEN USING EARLY BINDING WHEN A PARAMETER
'IS A CONTROL OR A CUSTOM OBJECT.  IF YOU JUST PLUG THIS INTO
'A FORM, YOU CAN DECLARE RTFCONTROL AS RICHTEXTBOX
'AND COMMENT OUT THE FOLLOWING LINE

If Not TypeOf RTFControl Is RichTextBox Then Exit Sub
'**************************************************************
   
   Dim lngLeftOffset As Long
   Dim lngTopOffSet As Long
   Dim lngLeftMargin As Long
   Dim lngTopMargin As Long
   Dim lngRightMargin As Long
   Dim lngBottomMargin As Long
   
   Dim typFr As FormatRange
   Dim rectPrintTarget As RECT
   Dim rectPage As RECT
   Dim lngTxtLen As Long
   Dim lngPos As Long
   Dim lngRet As Long
   Dim iTempScaleMode As Integer
   
   iTempScaleMode = Printer.ScaleMode
   
   ' needed to get a Printer.hDC
   Printer.Print ""
   Printer.ScaleMode = vbTwips
   
   ' Get the offsets to printable area in twips
   lngLeftOffset = Printer.ScaleX(GetDeviceCaps(Printer.hdc, _
      PHYSICALOFFSETX), vbPixels, vbTwips)
   lngTopOffSet = Printer.ScaleY(GetDeviceCaps(Printer.hdc, _
      PHYSICALOFFSETY), vbPixels, vbTwips)

   ' Get Margins in Twips
   lngLeftMargin = MilimeterToTwips(LeftMargin) - lngLeftOffset
   lngTopMargin = MilimeterToTwips(TopMargin) - lngTopOffSet
   lngRightMargin = (Printer.Width - _
       MilimeterToTwips(RightMargin)) - lngLeftOffset
   
    lngBottomMargin = (Printer.Height - _
         MilimeterToTwips(BottomMargin)) - lngTopOffSet

   ' Set printable area rect
   rectPage.Left = 0
   rectPage.Top = 0
   rectPage.Right = Printer.ScaleWidth
   rectPage.Bottom = Printer.ScaleHeight

   ' Set rect in which to print, based on margins passed in
   rectPrintTarget.Left = lngLeftMargin
   rectPrintTarget.Top = lngTopMargin
   rectPrintTarget.Right = lngRightMargin
   rectPrintTarget.Bottom = lngBottomMargin

   ' Set up the printer for this print job
   typFr.hdc = Printer.hdc 'for rendering
   typFr.hdcTarget = Printer.hdc 'for formatting
   typFr.rc = rectPrintTarget
   typFr.rcPage = rectPage
   typFr.chrg.cpMin = 0
   typFr.chrg.cpMax = -1

   ' Get length of text in the RichTextBox Control
   lngTxtLen = Len(RTFControl.Text)

   ' print page by page
   Do
      ' Print the page by sending EM_FORMATRANGE message
      'Allows you to range of text within a specific device
      'here, the device is the printer, which must be specified
      'as hdc and hdcTarget of the FORMATRANGE structure
      
      lngPos = SendMessage(RTFControl.hwnd, EM_FORMATRANGE, _
        True, typFr)
  
       If lngPos >= lngTxtLen Then Exit Do  'Done
       typFr.chrg.cpMin = lngPos ' Starting position next page
      Printer.NewPage             ' go to next page
      Printer.Print ""   'to get hDC again
      typFr.hdc = Printer.hdc
      typFr.hdcTarget = Printer.hdc
   Loop

   ' Done
   Printer.EndDoc

   ' This frees memory
   lngRet = SendMessage(RTFControl.hwnd, EM_FORMATRANGE, _
     False, Null)
   Printer.ScaleMode = iTempScaleMode

Exit Sub
ErrorHandler:
   Fehlermeldung
End Sub

Public Sub StandartPrintRTB(RTF As RichTextBox, LeftMarginWidth As Long, _
             TopMarginHeight As Long, RightMarginWidth As Long, _
             BottomMarginHeight As Long)
             
'***************************************************************

On Error GoTo ErrorHandler


'*************************************************************
'I DO THIS BECAUSE IT IS MY UNDERSTANDING THAT
'WHEN CALLING A SERVER DLL, YOU CAN RUN INTO
'PROBLEMS WHEN USING EARLY BINDING WHEN A PARAMETER
'IS A CONTROL OR A CUSTOM OBJECT.  IF YOU JUST PLUG THIS INTO
'A FORM, YOU CAN DECLARE RTF AS RICHTEXTBOX
'AND COMMENT OUT THE FOLLOWING LINE

If Not TypeOf RTF Is RichTextBox Then Exit Sub

    Call StandartisierteEinstellungen
    
             
Dim LeftOffSet As Long, TopOffSet As Long
Dim LeftMargin As Long, TopMargin As Long
Dim RightMargin As Long, BottomMargin As Long
Dim fr As FormatRange
Dim rcDrawTo As RECT
Dim rcPage As RECT
Dim TextLength As Long
Dim NextCharPosition As Long
Dim r As Long

   Dim iTempScaleMode As Integer
   
   iTempScaleMode = Printer.ScaleMode
   
Dim strHeader As String
Dim strFooter As String

    ' Kopf- und Fusszeile
    strHeader = strKopfzeile
    strFooter = strFuzeile
    
'    MsgBox "strHeader : " & strHeader & vbCrLf & "strFooter : " & strFooter, vbInformation
'
'    Exit Sub
    
    'Initialisierung des Printers
    Printer.Print ""
    Printer.ScaleMode = vbTwips
    
    'Linken und Oberen Offset auslesen
    LeftOffSet = Printer.ScaleX(GetDeviceCaps(Printer.hdc, _
                                PHYSICALOFFSETX), vbPixels, _
                                vbTwips)
                                
    TopOffSet = Printer.ScaleY(GetDeviceCaps(Printer.hdc, _
                               PHYSICALOFFSETY), vbPixels, _
                               vbTwips)
   
    'Rnder berechnen
    LeftMargin = LeftMarginWidth - LeftOffSet
    TopMargin = TopMarginHeight - TopOffSet
    RightMargin = (Printer.ScaleWidth - RightMarginWidth) _
                   + LeftOffSet
                   
    BottomMargin = (Printer.ScaleHeight - BottomMarginHeight) _
                    + TopOffSet
    
    'Druckbarer Bereich in einer Variable speichern
    rcPage.Left = 0
    rcPage.Top = 0
    rcPage.Right = Printer.ScaleWidth
    rcPage.Bottom = Printer.ScaleHeight
    
    'Bereich in einer Veriable speichern, in dem gedruckt
    'werden soll
    rcDrawTo.Left = LeftMargin
    rcDrawTo.Top = TopMargin
    rcDrawTo.Right = RightMargin
    rcDrawTo.Bottom = BottomMargin
    
    'Druckerinstruktionen festlegen
    fr.hdc = Printer.hdc
    fr.hdcTarget = Printer.hdc
    fr.rc = rcDrawTo
    fr.rcPage = rcPage
    fr.chrg.cpMin = 0
    fr.chrg.cpMax = -1
    
    'Textlnge bestimmen
    TextLength = Len(RTF.Text)
    
        'Schriftgrsse/-art fr Kopf-/Fusszeilen
        If strPrinterFont = "" Then
            Printer.Font = "Courier New" '"Arial"
        Else
            Printer.Font = strPrinterFont
        End If
        
        If iPrinterFontSize = 0 Then
            Printer.FontSize = 11
        Else
            Printer.FontSize = iPrinterFontSize
        End If
        
        Printer.FontBold = bolPrinterFontBold
        Printer.FontItalic = bolPrinterFontItalic
        Printer.FontStrikethru = bolPrinterFontStrikethru
        Printer.FontUnderline = bolPrinterFontUnderline
    
       
    'Loop der alle Seiten ausdruckt
    Dim i As Integer:    i = 1
    Do
        'Text mit EM_FORMATRANGE ausdrucken
        NextCharPosition = SendMessage(RTF.hwnd, EM_FORMATRANGE, _
                                       1, fr)
        'Kopfzeile ausdrucken
        Printer.CurrentX = (Printer.ScaleWidth - _
                            Printer.TextWidth(strHeader)) / 2
                            
        Printer.CurrentY = (TopMargin - Printer.TextHeight("x")) _
                            / 2
                            
        Printer.Print strHeader
        'Fusszeile ausdrucken
        Printer.CurrentX = (Printer.ScaleWidth - _
                            Printer.TextWidth(strFooter)) / 2
                            
        Printer.CurrentY = BottomMargin + (Printer.ScaleHeight _
                           - BottomMargin - Printer.TextHeight("x"))
                           
        Printer.Print strFooter
        'Seitennummer ausdrucken
        Printer.CurrentX = Printer.ScaleWidth - _
                           Printer.TextWidth("Seite " & i & "  ")
                           
        Printer.CurrentY = BottomMargin + (Printer.ScaleHeight - _
                           BottomMargin - Printer.TextHeight("x"))
                           
        Printer.Print "Seite " & i
        'Falls alles ausgedruckt ist, Schleife verlassen
        If NextCharPosition >= TextLength Then Exit Do
        
        'Startposition fr die nchste Seite
        fr.chrg.cpMin = NextCharPosition
        'Neue Seite beginnen
        Printer.NewPage
        Printer.Print ""
        fr.hdc = Printer.hdc
        fr.hdcTarget = Printer.hdc
        i = i + 1
    Loop
    
    'Druckauftrag abschliessen
    Printer.EndDoc
    
    'Control zurcksetzten
    r = SendMessage(RTF.hwnd, EM_FORMATRANGE, 0, ByVal CLng(0))
    
    Printer.ScaleMode = iTempScaleMode
    
    DeleteDC PrtDC
    
    strKopfzeile = ""
    strFuzeile = ""
    
Exit Sub
ErrorHandler:
   Fehlermeldung
End Sub

Private Sub StandartisierteEinstellungen()

Dim bw&, bH&, r&
Dim TopOffSet As Long
Dim LeftOffSet As Long

' Randeinstellungen
' Angaben umgerechnet in Twips
ObererRand = MilimeterToTwips(AbstandObererRand)
LinkerRand = MilimeterToTwips(AbstandLinkerRand)
RechterRand = MilimeterToTwips(AbstandRechterRand)
UntererRand = MilimeterToTwips(AbstandUntererRand)

' Druckerrnder
' Linken Offset auslesen
LeftOffSet = Printer.ScaleX(GetDeviceCaps(Printer.hdc, _
             PHYSICALOFFSETX), vbPixels, vbTwips)
   
Dim LeftMargin As Long
Dim RightMargin As Long
Dim linewidth As Long

' Eingestellter Druckbereich
LeftMargin = LinkerRand - LeftOffSet
RightMargin = (Printer.Width - RechterRand) - LeftOffSet

' Wird bentigt um der RTB die exacte Breite zu bergeben
linewidth = RightMargin - LeftMargin

' Einen hDC vom Drucker erstellen fr die RTB in WYSIWYG
PrtDC = CreateDC(Printer.DriverName, Printer.DeviceName, 0, 0)

' Der RTF sagen das sie sich dem Druckbild anpassen soll (WYSIWYG)
r = SendMessage(FrmEditor.RichTextBox1.hwnd, EM_SETTARGETDEVICE, PrtDC, _
                ByVal linewidth)

End Sub

Public Function MilimeterToTwips(ByVal Inches As Single) As Single
    MilimeterToTwips = 57 * Inches '570 * Inches
End Function
   

   ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
   '
   ' WYSIWYG_RTF - Sets an RTF control to display itself the same as it
   '               would print on the default printer
   '
   ' RTF - A RichTextBox control to set for WYSIWYG display.
   '
   ' LeftMarginWidth - Width of desired left margin in twips
   '
   ' RightMarginWidth - Width of desired right margin in twips
   '
   ' Returns - The length of a line on the printer in twips
   '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  Public Function WYSIWYG_RTF(RTF As RichTextBox, _
       LeftMarginWidth As Long, _
      RightMarginWidth As Long, Enabled As Boolean) As Long
      Dim LeftOffSet As Long, LeftMargin As Long, RightMargin As Long
      Dim linewidth As Long
      Dim PrinterhDC As Long
      Dim r As Long
      
      If Enabled = True Then
      
          ' Start a print job to initialize printer object
          Printer.Print Space(1)
          Printer.ScaleMode = vbTwips
    
          ' Get the offset to the printable area on the page in twips
          LeftOffSet = Printer.ScaleX(GetDeviceCaps(Printer.hdc, _
             PHYSICALOFFSETX), vbPixels, vbTwips)
    
          ' Calculate the Left, and Right margins
          LeftMargin = LeftMarginWidth - LeftOffSet
          RightMargin = (Printer.Width - RightMarginWidth) - LeftOffSet
    
          ' Calculate the line width
          linewidth = RightMargin - LeftMargin
    
          ' Create an hDC on the Printer pointed to by the Printer object
          ' This DC needs to remain for the RTF to keep up the WYSIWYG display
          PrinterhDC = CreateDC(Printer.DriverName, Printer.DeviceName, 0, 0)
    
          ' Tell the RTF to base it's display off of the printer
          '    at the desired line width
          r = SendMessage(RTF.hwnd, EM_SETTARGETDEVICE, PrinterhDC, _
             ByVal linewidth)
    
          ' Abort the temporary print job used to get printer info
          Printer.KillDoc

      WYSIWYG_RTF = linewidth
      
      Else
      
        'Turn OFF WYSWYG Display.
        SendMessageLong RTF.hwnd, EM_SETTARGETDEVICE, 0, 0
              
        WYSIWYG_RTF = RTF.Width
        
      End If
      
   End Function
   
Private Sub FooterPrint(LeftMargin As Long, BottomMargin As Long)
 Dim txtWidth As Long
 Dim MaxWidth As Long

 Prs = gFooter
 gAlign = 0
 MaxWidth = Printer.Width - LeftMargin * 2


'footer y location is constant
 Printer.CurrentY = BottomMargin + 360

 ParseHF Prs, gPageNumber

 txtWidth = Printer.TextWidth(Prs)

   Select Case gAlign
   
     Case 0 'left align
        Printer.CurrentX = LeftMargin

     Case 1 'center align
        Printer.CurrentX = (LeftMargin + (MaxWidth - txtWidth) / 2) - LeftMargin / 2
        
     Case 2 'right align
        Printer.CurrentX = (LeftMargin + (MaxWidth - txtWidth)) - LeftMargin / 2

        
  End Select
  
  Printer.Print Prs 'print the parsed footer
  
End Sub


Private Sub HeaderPrint(LeftMargin As Long, TopMargin As Long)
 Dim txtWidth As Long
 Dim MaxWidth As Long

 Prs = gHeader
 gAlign = 0
 MaxWidth = Printer.Width - LeftMargin * 2


'location is constant
 Printer.CurrentY = TopMargin - 360
 
 ParseHF Prs, gPageNumber
 
 txtWidth = Printer.TextWidth(Prs)
 

   Select Case gAlign
   
     Case 0 'left align
        Printer.CurrentX = LeftMargin

     Case 1 'center align
        Printer.CurrentX = (LeftMargin + (MaxWidth - txtWidth) / 2) - LeftMargin
        
     Case 2 'right align
        Printer.CurrentX = (LeftMargin + (MaxWidth - txtWidth)) - LeftMargin / 2

        
  End Select
  
  Printer.Print Prs 'print the parsed header


End Sub


Private Sub ParseHF(Prs$, gPageNumber)

'************************************************************
'This parses out requests for alignment of header/footer as
'well as request for page numbers, date, time filename
'************************************************************

Dim Pars As Integer

Pars = InStr(Prs$, "&p")
 If Pars Then
  Prs$ = Mid$(Prs$, 1, Pars - 1) & str$(gPageNumber) & Mid$(Prs$, Pars + 2, Len(Prs$))
 End If
 
Pars = InStr(Prs$, "&f")
 If Pars Then
  Prs$ = Mid$(Prs$, 1, Pars - 1) & strPrintFile & Mid$(Prs$, Pars + 2, Len(Prs$))
 End If
 
 Pars = InStr(Prs$, "&d")
  If Pars Then
   Prs$ = Mid$(Prs$, 1, Pars - 1) & Format(Now, "dddd, mmmm dd, yyyy") & Mid$(Prs$, Pars + 2, Len(Prs$))
  End If
  
 Pars = InStr(Prs$, "&t")
  If Pars Then
   Prs$ = Mid$(Prs$, 1, Pars - 1) & Format(Now, "h:mm AM/PM") & Mid$(Prs$, Pars + 2, Len(Prs$))
  End If

'Parse for alignment
 Pars = InStr(Prs$, "&r") 'right align
  If Pars Then
   gAlign = 2
   Prs$ = Mid$(Prs$, 1, Pars - 1) & Mid$(Prs$, Pars + 2, Len(Prs$))
  End If
  
 Pars = InStr(Prs$, "&c") 'center align
  If Pars Then
   gAlign = 1
   Prs$ = Mid$(Prs$, 1, Pars - 1) & Mid$(Prs$, Pars + 2, Len(Prs$))
  End If
  
 Pars = InStr(Prs$, "&l") 'center align
  If Pars Then
   gAlign = 0
   Prs$ = Mid$(Prs$, 1, Pars - 1) & Mid$(Prs$, Pars + 2, Len(Prs$))
  End If
 
End Sub

Public Sub PrintRTF(RTF As RichTextBox, LeftMarginWidth As Long, TopMarginHeight, RightMarginWidth, BottomMarginHeight)
      
'*****************************************************************************
'* This code largely from Microsoft KB - Modified by me for header/footers   *
'*****************************************************************************

On Error Resume Next

      Dim LeftOffSet As Long, TopOffSet As Long
      Dim LeftMargin As Long, TopMargin As Long
      Dim RightMargin As Long, BottomMargin As Long
      Dim fr As FormatRange
      Dim rcDrawTo As RECT
      Dim rcPage As RECT
      Dim TextLength As Long
      Dim NextCharPosition As Long
      Dim r As Long

      ' Start a print job to get a valid Printer.hDC
      
      Printer.Print " ";
      Printer.ScaleMode = vbTwips
      Printer.Font.size = FrmEditor.RichTextBox1.Font.size
      

      DoEvents

      ' Get the offsett to the printable area on the page in twips
      LeftOffSet = Printer.ScaleX(GetDeviceCaps(Printer.hdc, _
         PHYSICALOFFSETX), vbPixels, vbTwips)
      TopOffSet = Printer.ScaleY(GetDeviceCaps(Printer.hdc, _
         PHYSICALOFFSETY), vbPixels, vbTwips)

      ' Calculate the Left, Top, Right, and Bottom margins
      LeftMargin = LeftMarginWidth - LeftOffSet
      TopMargin = TopMarginHeight - TopOffSet
      RightMargin = (Printer.Width - RightMarginWidth) - LeftOffSet
      BottomMargin = (Printer.Height - BottomMarginHeight) - TopOffSet

      ' Set printable area rect
      rcPage.Left = 0
      rcPage.Top = 0
      rcPage.Right = Printer.ScaleWidth
      rcPage.Bottom = Printer.ScaleHeight

      ' Set rect in which to print (relative to printable area)
      rcDrawTo.Left = LeftMargin
      rcDrawTo.Top = TopMargin
      rcDrawTo.Right = RightMargin
      rcDrawTo.Bottom = BottomMargin

      ' Set up the print instructions
      fr.hdc = Printer.hdc   ' Use the same DC for measuring and rendering
      fr.hdcTarget = Printer.hdc  ' Point at printer hDC
      fr.rc = rcDrawTo            ' Indicate the area on page to draw to
      fr.rcPage = rcPage          ' Indicate entire size of page
      fr.chrg.cpMin = 0           ' Indicate start of text through
      fr.chrg.cpMax = -1          ' end of the text

      ' Get length of text in RTF
      TextLength = Len(RTF.Text)
      gPageNumber = 1

      ' Loop printing each page until done
      Do
        
        'Chk to see if we're printing header
        If Len(gHeader) Then
         Call HeaderPrint(LeftMargin, TopMargin)
        End If
           
         ' Print the page by sending EM_FORMATRANGE message
         NextCharPosition = SendMessage(RTF.hwnd, _
             EM_FORMATRANGE, True, fr)
             
        'Chk to see if we're printing footer
        If Len(gFooter) Then
         Call FooterPrint(LeftMargin, BottomMargin)
        End If
        
        'increment print page number
        gPageNumber = gPageNumber + 1
      
         If NextCharPosition >= TextLength Then Exit Do  'If done then exit
         fr.chrg.cpMin = NextCharPosition ' Starting position for next page
         Printer.NewPage                  ' Move on to next page
         Printer.Print Space(1) ' Re-initialize hDC
         fr.hdc = Printer.hdc
         fr.hdcTarget = Printer.hdc
      Loop

      ' Commit the print job
      Printer.EndDoc

      ' Allow the RTF to free up memory
      r = SendMessage(RTF.hwnd, EM_FORMATRANGE, False, ByVal CLng(0))
      
   End Sub


