Attribute VB_Name = "mdlReg"
Option Explicit

Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const KEY_ALL_ACCESS = &H3F
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const REG_PRIMARY_KEY = "Software\Classes\"
Private Const REG_SHELL_KEY = "Shell\"
Private Const REG_SHELL_OPEN_KEY = "Open\"
Private Const REG_SHELL_OPEN_COMMAND_KEY = "Command"
Private Const REG_ICON_KEY = "DefaultIcon"
Private Const REG_SZ = 1
Private Const REG_OPTION_NON_VOLATILE = 0
Private Const ERROR_SUCCESS = 0&

Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Boolean
End Type

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hkey As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hkey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hkey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" (ByVal hkey As Long, ByVal lpSubKey As Any, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hkey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hkey As Long, ByVal lpValueName As String) As Long

Private Function OpenKey(lhKey As Long, SubKey As String, ulOptions As Long) As Long
Dim lhKeyOpen As Long
Dim lResult As Long

lhKeyOpen = 0
lResult = RegOpenKeyEx(lhKey, SubKey, 0, ulOptions, lhKeyOpen)

If lResult <> ERROR_SUCCESS Then
OpenKey = 0
Else
OpenKey = lhKeyOpen
End If
End Function

Private Function CreateKey(lhKey As Long, SubKey As String, NewSubKey As String) As Boolean
Dim lhKeyOpen As Long
Dim lhKeyNew As Long
Dim lDisposition As Long
Dim lResult As Long
Dim Security As SECURITY_ATTRIBUTES

lhKeyOpen = OpenKey(lhKey, SubKey, KEY_CREATE_SUB_KEY)
lResult = RegCreateKeyEx(lhKeyOpen, NewSubKey, 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, Security, lhKeyNew, lDisposition)

If lResult = ERROR_SUCCESS Then
CreateKey = True
RegCloseKey (lhKeyNew)
Else
CreateKey = False
End If

RegCloseKey (lhKeyOpen)
End Function

Private Function SetValue(lhKey As Long, SubKey As String, sValue As String) As Boolean
Dim lhKeyOpen As Long
Dim lResult As Long
Dim lTyp As Long
Dim lByte As Long

lByte = Len(sValue)
lTyp = REG_SZ
lhKeyOpen = OpenKey(lhKey, SubKey, KEY_SET_VALUE)
lResult = RegSetValue(lhKey, SubKey, lTyp, sValue, lByte)

If lResult <> ERROR_SUCCESS Then
SetValue = False
Else
SetValue = True
RegCloseKey (lhKeyOpen)
End If
End Function

Private Function DeleteKey(sKey As String) As Long
DeleteKey = RegDeleteKey(HKEY_LOCAL_MACHINE, REG_PRIMARY_KEY & "\" & App.EXEName & "\" & sKey)
End Function

Public Sub DelExtension()
Call DeleteKey("DefaultIcon")
Call DeleteKey("Shell\Open\Command")
Call DeleteKey("Shell\Open")
Call DeleteKey("Shell")
Call RegDeleteKey(HKEY_LOCAL_MACHINE, REG_PRIMARY_KEY & "\" & App.EXEName)
End Sub

Public Function RegExtension(sFileExt As String, sFileDescr As String, sAppID As String, sOpenCmd As String, sIconFile As String) As Boolean
Dim hkey As Long
Dim bSuccess As Boolean
Dim bSuccess2 As Boolean
    
bSuccess = False
hkey = HKEY_LOCAL_MACHINE
  
If CreateKey(hkey, REG_PRIMARY_KEY, sFileExt) Then
    If SetValue(hkey, REG_PRIMARY_KEY & sFileExt, sAppID) Then
        If CreateKey(hkey, REG_PRIMARY_KEY, sAppID) Then
            If SetValue(hkey, REG_PRIMARY_KEY & sAppID, sFileDescr) Then
                If CreateKey(hkey, REG_PRIMARY_KEY & sAppID, _
                    REG_SHELL_KEY & REG_SHELL_OPEN_KEY & _
                    REG_SHELL_OPEN_COMMAND_KEY) Then
                bSuccess = SetValue(hkey, REG_PRIMARY_KEY & _
                    sAppID & "\" & REG_SHELL_KEY & _
                    REG_SHELL_OPEN_KEY & _
                    REG_SHELL_OPEN_COMMAND_KEY, sOpenCmd)
                    If CreateKey(hkey, REG_PRIMARY_KEY & sAppID, REG_ICON_KEY) Then
                    bSuccess2 = SetValue(hkey, REG_PRIMARY_KEY & sAppID & "\" & _
                        REG_ICON_KEY, sIconFile)
                    End If
                End If
            End If
        End If
    End If
End If

RegExtension = (bSuccess = bSuccess2)
End Function

Public Function TextRead(Filename) As String
On Error GoTo Fehlerbehandlung

Dim number As Long
Dim size As Long
number = FreeFile
    Open Filename For Input As number
        size = LOF(number)
        TextRead = Input(size, number)
    Close number

Exit Function
Fehlerbehandlung:
Call Fehlermeldung
End Function

Public Sub TextSave(Filename As String, ByVal Text As String)
On Error GoTo Fehlerbehandlung

Dim number As Long
number = FreeFile
    Open Filename For Output As number
            Print #number, Trim(Text)
    Close number

Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub
