Attribute VB_Name = "mdlSound"
Option Explicit


'Konstante          Bedeutung                                       Wert
'SND_ASYNC          Das Programm wartet nicht bis der Sound         1
'                   abgespielt wurde.

'SND_NODEFAULT      Wenn die angegebene Datei nicht gefunden        2
'                   werden konnte, wird nicht der Standartklang
'                   abgespiel.

'SND_SYNC           Der Programm fhrt erst fort, wenn der Sound    0
'                   abgespielt wurde

'SND_LOOP           Der Sound wird solange wiederholt abgespielt    8
'                   bis die sndPlaySound-Funktion erneut, diesmal
'                   aber mit vbNullString anstelle eines Datei-
'                   namens, aufgerufen wird,

'SND_NOSTOP         Der angegebene Sound wird nicht gespielt,       16
'                   wenn gerade ein anderer Sound gespielt wird.

'*** Sound-Funktionen ***
'----------------------------------------------------------------------------------------
'fr das Abspielen aus der Ressource-Datei
Private Const SND_SYNC = &H0
Private Const SND_ASYNC = &H1
Private Const SND_NODEFAULT = &H2
Private Const SND_MEMORY = &H4
Private Const SND_LOOP = &H8
Private Const SND_NOSTOP = &H10
Private Const SND_PURGE = &H40
Private Const SND_NOWAIT = &H2000

'Public Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" _
(ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Public Declare Function sndPlaySoundA Lib "Winmm" (ByVal IpszSoundName As String, _
        ByVal fuOptions As Integer) As Integer

Public Sound$
'----------------------------------------------------------------------------------------
Public Type mAppSounds
    mAblehnenSound As String
    mAnnehmenSound As String
    mClickSound As String
    mDateiffnenSound As String
    mDateiSchlieenSound As String
    mErinnerungsSound As String
    mFehlerSound As String
    mFensterffnenSound As String
    mFensterSchlieenSound As String
    mFrageSound As String
    mHinweisSound As String
    mLschenSound As String
    mStartSound As String
    mSchlieenSound As String
    mMenSound As String
End Type

Public Enum eAppSounds
    eAblehnenSound = 0
    eAnnehmenSound = 1
    eClickSound = 2
    eDateiffnenSound = 3
    eDateiSchlieenSound = 4
    eErinnerungsSound = 5
    eFehlerSound = 6
    eFensterffnenSound = 7
    eFensterSchlieenSound = 8
    eFrageSound = 9
    eHinweisSound = 10
    eLschenSound = 11
    eSchlieenSound = 12
    eStartSound = 13
    eMenSound = 14
End Enum

Public PathSound As mAppSounds

' Speichern
Public Sub AppSounds_Save()
On Error GoTo Fehlerbehandlung

Dim Buchstabe As String
'Eingabe\FSO-Drives.frm
Dim fso As New FileSystemObject
Dim dR As Drive
Dim drSpeicherLaufwerk As String

    Screen.MousePointer = vbHourglass

'fr dr (Laufwerk) sind die ersten 2 Zeichen wichtig und mssen ermittelt werden
Buchstabe = Left(Laufwerk, 2)

'bei nicht betriebsbereitem Laufwerk
On Error Resume Next

For Each dR In fso.Drives
    'Laufwerksbuchstaben einsetzen
    'den Laufwerkstyp ermitteln
    If dR = Buchstabe Then
        Select Case dR.DriveType
            Case Is = CDRom
                drSpeicherLaufwerk = "CD-Rom"
            Case Is = Fixed
                drSpeicherLaufwerk = "Festplatte"
            Case Is = RamDisk
                drSpeicherLaufwerk = "Ram-Disk"
            Case Is = Remote
                drSpeicherLaufwerk = "Netzlaufwerk"
            Case Is = Removable
                drSpeicherLaufwerk = "Wechseldatentrger"
            Case Else
                drSpeicherLaufwerk = "Unbekannt"
        End Select
    'wenn gefunden Schleife verlassen
    Exit For
    End If
Next
Screen.MousePointer = vbDefault

'der Laufwerkstyp ist nun ermittelt

If dR.DriveType <> CDRom Then

  Dim f As Integer

  ' Neues PropertyBag-Objekt erstellen
  Dim myPropBag As New PropertyBag

  ' Einstellungen zunchst im PropertyBag-Objekt speichern
  With myPropBag
'---------------------------------------------------------------------------------------------
'speichert die Sound - Einstellungen
    .WriteProperty "StartSound", PathSound.mStartSound, ""
    .WriteProperty "SchlieenSound", PathSound.mSchlieenSound, ""
    .WriteProperty "DateiffnenSound", PathSound.mDateiffnenSound, ""
    .WriteProperty "DateiSchlieenSound", PathSound.mDateiSchlieenSound, ""
    .WriteProperty "ErinnerungsSound", PathSound.mErinnerungsSound, ""
    .WriteProperty "FensterffnenSound", PathSound.mFensterffnenSound, ""
    .WriteProperty "FensterSchlieenSound", PathSound.mFensterSchlieenSound, ""
    .WriteProperty "FehlerSound", PathSound.mFehlerSound, ""
    .WriteProperty "ClickSound", PathSound.mClickSound, ""
    .WriteProperty "LschenSound", PathSound.mLschenSound, ""
    .WriteProperty "FrageSound", PathSound.mFrageSound, ""
    .WriteProperty "AblehnenSound", PathSound.mAblehnenSound, ""
    .WriteProperty "AnnehmenSound", PathSound.mAnnehmenSound, ""
    .WriteProperty "HinweisSound", PathSound.mHinweisSound, ""
    .WriteProperty "MenSound", PathSound.mMenSound, ""
'---------------------------------------------------------------------------------------------
  End With

  ' Jetzt den Inhalt des PropertyBags speichern
  ' Falls die Datei existiert - vorher lschen!
  If Dir$(Laufwerk & "AppSounds.dat", vbNormal) <> "" Then _
    Kill Laufwerk & "AppSounds.dat"

  f = FreeFile
  Open Laufwerk & "AppSounds.dat" For Binary As #f
    Put #f, , myPropBag.Contents
  Close #f

End If
    Set fso = Nothing
    Set dR = Nothing
    
Exit Sub
Fehlerbehandlung:
    Set fso = Nothing
    Set dR = Nothing
    
Call Fehlermeldung
End Sub

' Lesen
Public Sub AppSounds_Load()
  Dim f As Integer
  Dim vInhalt As Variant

  ' Neues PropertyBag-Objekt erstellen
  Dim myPropBag As New PropertyBag

  ' Datei-Inhalt einlesen
  If Dir$(Laufwerk & "AppSounds.dat", vbNormal) <> "" Then
    f = FreeFile
    Open Laufwerk & "AppSounds.dat" For Binary As #f
    Get #f, , vInhalt
    Close #f

    ' Inhalt dem PropertyBag-Objekt zuweisen
    myPropBag.Contents = vInhalt

    ' Einstellungen den Controls zuweisen
    With myPropBag
    '---------------------------------------------------------------------------------------------------------------------------
    'ldt die gespeicherten Sounds
        PathSound.mStartSound = .ReadProperty("StartSound", "")
        PathSound.mSchlieenSound = .ReadProperty("SchlieenSound", "")
        PathSound.mDateiffnenSound = .ReadProperty("DateiffnenSound", "")
        PathSound.mDateiSchlieenSound = .ReadProperty("DateiSchlieenSound", "")
        PathSound.mErinnerungsSound = .ReadProperty("ErinnerungsSound", "")
        PathSound.mFensterffnenSound = .ReadProperty("FensterffnenSound", "")
        PathSound.mFensterSchlieenSound = .ReadProperty("FensterSchlieenSound", "")
        PathSound.mFehlerSound = .ReadProperty("FehlerSound", "")
        PathSound.mClickSound = .ReadProperty("ClickSound", "")
        PathSound.mLschenSound = .ReadProperty("LschenSound", "")
        PathSound.mFrageSound = .ReadProperty("FrageSound", "")
        PathSound.mAblehnenSound = .ReadProperty("AblehnenSound", "")
        PathSound.mAnnehmenSound = .ReadProperty("AnnehmenSound", "")
        PathSound.mHinweisSound = .ReadProperty("HinweisSound", "")
        PathSound.mMenSound = .ReadProperty("MenSound", "")
    '---------------------------------------------------------------------------------------------------------------------------
    End With
    
    With PathSound
        'Pfad auf Existens prfen
        If IsFilePath(.mStartSound) = False Then
            .mStartSound = ""
        End If
        If IsFilePath(.mSchlieenSound) = False Then
            .mSchlieenSound = ""
        End If
        If IsFilePath(.mDateiffnenSound) = False Then
            .mDateiffnenSound = ""
        End If
        If IsFilePath(.mDateiSchlieenSound) = False Then
            .mDateiSchlieenSound = ""
        End If
        If IsFilePath(.mErinnerungsSound) = False Then
            .mErinnerungsSound = ""
        End If
        If IsFilePath(.mFehlerSound) = False Then
            .mFehlerSound = ""
        End If
        If IsFilePath(.mFensterffnenSound) = False Then
            .mFensterffnenSound = ""
        End If
        If IsFilePath(.mFensterSchlieenSound) = False Then
            .mFensterSchlieenSound = ""
        End If
        If IsFilePath(.mClickSound) = False Then
            .mClickSound = ""
        End If
        If IsFilePath(.mLschenSound) = False Then
            .mLschenSound = ""
        End If
        If IsFilePath(.mFrageSound) = False Then
            .mFrageSound = ""
        End If
        If IsFilePath(.mAblehnenSound) = False Then
            .mAblehnenSound = ""
        End If
        If IsFilePath(.mAnnehmenSound) = False Then
            .mAnnehmenSound = ""
        End If
        If IsFilePath(.mHinweisSound) = False Then
            .mHinweisSound = ""
        End If
        If IsFilePath(.mMenSound) = False Then
            .mMenSound = ""
        End If
    End With
  End If
End Sub

Public Sub PlayStartSound()
With PathSound
    If IsFilePath(.mStartSound) Then
        Sound$ = sndPlaySoundA(.mStartSound, 2 Or 1)
    End If
End With
End Sub

Public Sub PlayClickSound()
With PathSound
    If IsFilePath(.mClickSound) Then
        Sound$ = sndPlaySoundA(.mClickSound, 2 Or 1)
    End If
End With
End Sub

Public Sub PlayHinweisSound()
With PathSound
    If IsFilePath(.mHinweisSound) Then
        Sound$ = sndPlaySoundA(.mHinweisSound, 2 Or 1)  '15
    End If
End With
End Sub

Public Sub PlayFehlerSound()
With PathSound
    If IsFilePath(.mFehlerSound) Then
        Sound$ = sndPlaySoundA(.mFehlerSound, 2 Or 1)
    End If
End With
End Sub

Public Sub PlayFrageSound()
With PathSound
    If IsFilePath(.mFrageSound) Then
        Sound$ = sndPlaySoundA(.mFrageSound, 2 Or 1)
    End If
End With
End Sub

Public Sub PlayAnnehmenSound()
With PathSound
    If IsFilePath(.mAnnehmenSound) Then
        Sound$ = sndPlaySoundA(.mAnnehmenSound, 2 Or 1)  '13
    End If
End With
End Sub

Public Sub PlayAblehnenSound()
With PathSound
    If IsFilePath(.mAblehnenSound) Then
        Sound$ = sndPlaySoundA(.mAblehnenSound, 2 Or 1)  '11
    End If
End With
End Sub

Public Sub PlayLschSound()
With PathSound
    If IsFilePath(.mLschenSound) Then
        Sound$ = sndPlaySoundA(.mLschenSound, 2 Or 1)
    End If
End With
End Sub

Public Sub PlayDateiffnenSound()
With PathSound
    If IsFilePath(.mDateiffnenSound) Then
        Sound$ = sndPlaySoundA(.mDateiffnenSound, 2 Or 1)
    End If
End With
End Sub

Public Sub PlayErinnerungsSound()
With PathSound
    If IsFilePath(.mErinnerungsSound) Then
        Sound$ = sndPlaySoundA(.mErinnerungsSound, 2 Or 1)
    End If
End With
End Sub

Public Sub PlayDateiSchlieenSound()
With PathSound
    If IsFilePath(.mDateiSchlieenSound) Then
        Sound$ = sndPlaySoundA(.mDateiSchlieenSound, 2 Or 1)
    End If
End With
End Sub

Public Sub PlayFensterffnenSound()
With PathSound
    If IsFilePath(.mFensterffnenSound) Then
        Sound$ = sndPlaySoundA(.mFensterffnenSound, 2 Or 1)
    End If
End With
End Sub

Public Sub PlayFensterSchlieenSound()
With PathSound
    If IsFilePath(.mFensterSchlieenSound) Then
        Sound$ = sndPlaySoundA(.mFensterSchlieenSound, 2 Or 1)
    End If
End With
End Sub

Public Sub PlaySchlieenSound()
With PathSound
    If IsFilePath(.mSchlieenSound) Then
        Sound$ = sndPlaySoundA(.mSchlieenSound, 2 Or 0)
    End If
End With
End Sub

Public Sub PlayMenuSound()
With PathSound
    If IsFilePath(.mMenSound) Then
        Sound$ = sndPlaySoundA(.mMenSound, 2 Or 1)
    End If
End With
End Sub
