Attribute VB_Name = "mdlTermine"
Option Explicit

'Scrollen im FlexGrid Control mit der Wheel-Taste

Private Declare Function CallWindowProc Lib "user32" _
                                Alias "CallWindowProcA" _
                                (ByVal lpPrevWndFunc As Long, _
                                ByVal hwnd As Long, _
                                ByVal uMsg As Long, _
                                ByVal wparam As Long, _
                                ByVal lparam As Long) _
                                As Long

Public Declare Function SetWindowLong Lib "user32" _
                                Alias "SetWindowLongA" _
                                (ByVal hwnd As Long, _
                                ByVal nIndex As Long, _
                                ByVal dwNewLong As Long) _
                                As Long

Private Declare Function PostMessage Lib "user32" _
                                Alias "PostMessageA" _
                                (ByVal hwnd As Long, _
                                ByVal wMsg As Long, _
                                ByVal wparam As Long, _
                                ByVal lparam As Long) _
                                As Long


Private Const SB_LINEUP = 0
Private Const SB_LINEDOWN = 1
Private Const WHEEL_DELTA = 120

Private Const WM_MOUSEWHEEL = &H20A
Private Const GWL_WNDPROC   As Long = (-4)
Private Const WM_VSCROLL = &H115
Private OldWndProcessAdress As Long


Dim SerienTerminDatumVorhanden As Boolean
Public Termindatengendert As Boolean
Public Seriendatum As Date
Public SerienUhrzeit As Date
Public Termindatum As Date
Public Terminuhrzeit As Date
Public Terminvorhanden As Boolean
Public Terminladevorgang As Boolean

Public Terminvorschlagliste As String
'die Grnde werden in Terminbeschreibungliste.db gespeichert
Dim stTerminvorschlaglisteTemp As String
Dim iKanalNrTerminvorschlag As Integer
Dim TerminvorschlagNr As Integer
Public Const m_strStep As String = "|"

Public Stunde As Integer
Public Minute As Integer

Public Enum eTermin
 GridTerminNr = 0
 GridTerminDatum = 1
 GridTerminUhrzeit = 2
 GridTerminArt = 3
 GridTerminBeschreibung = 4
End Enum

Public r As Long

Public Function WMSysCommand(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wparam As Long, ByVal lparam As Long) As Long
    Dim n               As Long
    Dim ScrollDirection As Long
    Dim dvPos           As Long

    On Error GoTo procErr
    WMSysCommand = CallWindowProc(OldWndProcessAdress, hwnd, uMsg, wparam, lparam)
    If hwnd Then
        Select Case uMsg
            Case WM_MOUSEWHEEL
                dvPos = (wparam \ &H10000 \ WHEEL_DELTA)
                Debug.Print dvPos
                'Down = -1
                'Up   =  1
                Select Case dvPos
                    Case dvPos > 0
                        ScrollDirection = SB_LINEUP
                    Case dvPos < 0
                        ScrollDirection = SB_LINEDOWN
                End Select
                dvPos = Abs(dvPos)
                For n = 1 To dvPos
                    Call PostMessage(hwnd, WM_VSCROLL, ScrollDirection, 0)
                Next
        End Select
    End If
procErr:
    Exit Function
End Function

Public Sub HookSpecifiedWindow(ByVal hwnd As Long)
    OldWndProcessAdress = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WMSysCommand)
End Sub

Public Sub UnHookSpecifiedWindow(ByVal hwnd As Long)
    If OldWndProcessAdress <> 0 Then
        Call SetWindowLong(hwnd, GWL_WNDPROC, OldWndProcessAdress)
    End If
End Sub

Public Sub SetValue(ByVal datum As Date)
If IsDate(datum) Then
    'Das Drehfeld wird synchronisiert
    FrmTermine.UpDownDatum.Value = CLng(datum)
End If
End Sub

Public Sub Terminvorschlgeffnen()
On Error GoTo Fehlerbehandlung

'--------------------------------------------------------------------
'ffnen und einlesen der vorhandenen Termin Datumsangaben
'--------------------------------------------------------------------
On Error Resume Next
Terminvorschlagliste = Laufwerk & "Terminvorschlagliste.db"

iKanalNrTerminvorschlag = FreeFile() 'Range Nummer as Integer
'Einlesen der Eintrge in der TerminDatumliste
Open Terminvorschlagliste For Input As iKanalNrTerminvorschlag
'Beim ersten Start des Programms ist die Liste noch leer
    If Err.number > 0 Then
    'deshalb Prozedur verlassen
        Exit Sub
    End If
    
    Do While Not EOF(iKanalNrTerminvorschlag)
        Line Input #iKanalNrTerminvorschlag, stTerminvorschlaglisteTemp
        FrmTermine.cboTerminart.AddItem stTerminvorschlaglisteTemp
    Loop
    
Close iKanalNrTerminvorschlag

Exit Sub
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, App.EXEName
End Sub

Public Sub TerminvorschlgeSchlieen()
On Error GoTo Fehlerbehandlung

Dim Buchstabe As String
'Eingabe\FSO-Drives.frm
Dim fso As New FileSystemObject
Dim dr As Drive
Dim drLaufwerk As String


    Screen.MousePointer = vbHourglass
'das aktuelle Verzeichnis wird nun im mdlffentlicheVariablen gespeichert
'fr dr (Laufwerk) sind die ersten 2 Zeichen wichtig und mssen ermittelt werden
Buchstabe = Left(Laufwerk, 2)

'bei nicht betriebsbereitem Laufwerk
On Error Resume Next

For Each dr In fso.Drives
    'Laufwerksbuchstaben einsetzen
    'den Laufwerkstyp ermitteln
    If dr = Buchstabe Then
        Select Case dr.DriveType
            Case Is = CDRom
                drLaufwerk = "CD-Rom"
            Case Is = Fixed
                drLaufwerk = "Festplatte"
            Case Is = RamDisk
                drLaufwerk = "Ram-Disk"
            Case Is = Remote
                drLaufwerk = "Netzlaufwerk"
            Case Is = Removable
                drLaufwerk = "Wechseldatentrger"
            Case Else
                drLaufwerk = "Unbekannt"
        End Select
    'wenn gefunden Schleife verlassen
    Exit For
    End If
Next
Screen.MousePointer = vbDefault

'drLaufwerk, der Laufwerkstyp ist nun ermittelt _
und wird nun im mdlffentlicheVariablen gespeichert

If dr.DriveType <> CDRom Then

'--------------------------------------------------------------------
'ffnen und schreiben der vorhandenen Termin Datumsangaben
'--------------------------------------------------------------------
    On Error Resume Next
    Terminvorschlagliste = Laufwerk & "Terminvorschlagliste.db"
    
    iKanalNrTerminvorschlag = FreeFile() 'Range Nummer as Integer
    'schreiben der Eintrge von cboGericht in TerminDatumliste.db
    Open Terminvorschlagliste For Output As iKanalNrTerminvorschlag
    
       For TerminvorschlagNr = 0 To FrmTermine.cboTerminart.ListCount - 1
            Print #iKanalNrTerminvorschlag, FrmTermine.cboTerminart.List(TerminvorschlagNr)
       Next TerminvorschlagNr
    
    Close iKanalNrTerminvorschlag
End If

Set fso = Nothing
Set dr = Nothing

Exit Sub
Fehlerbehandlung:

Set fso = Nothing
Set dr = Nothing

MsgBox Err.Description, vbCritical, App.EXEName
End Sub

Public Sub TerminDatumUhrzeitprfen(ByVal Vergleichsdatum As Date, ByVal Vergleichsuhrzeit As Date)
On Error GoTo Fehlerbehandlung

With FrmTermine
    If Vergleichsdatum < Date Then
        .cmdbernehmen.Enabled = False
    ElseIf Vergleichsdatum > Date Then
        .cmdbernehmen.Enabled = True
    Else
        If Vergleichsuhrzeit > Time Then
            .cmdbernehmen.Enabled = True
        Else
            .cmdbernehmen.Enabled = False
        End If
    End If
End With

Exit Sub
Fehlerbehandlung:
End Sub

Public Sub TerminaufVorhandenseinprfen(ByVal Termindatum As Date, ByVal Terminuhrzeit As Date)
Terminvorhanden = False
Dim i As Long

With FrmTermine
    'in der Schleife prfen ob der Termin mit _
    gleicher Uhrzeit bereits vorhanden ist
    For i = 1 To .MSFlexGridTermine.Rows - 1
        If .chkSerientermin.Value = 0 Then  'normaler Termin
            If .MSFlexGridTermine.TextMatrix(i, eTermin.GridTerminDatum) = Termindatum _
            And .MSFlexGridTermine.TextMatrix(i, eTermin.GridTerminUhrzeit) = Terminuhrzeit Then
                'der Variable den entsprechenden Wert zuweisen
                Terminvorhanden = True
                'Schleife verlassen
                Exit For
            Else
                Terminvorhanden = False
            End If
        Else
            If .MSFlexGridTermine.TextMatrix(i, eTermin.GridTerminDatum) = Seriendatum _
            And .MSFlexGridTermine.TextMatrix(i, eTermin.GridTerminUhrzeit) = SerienUhrzeit Then
                'der Variable den entsprechenden Wert zuweisen
                Terminvorhanden = True
                'Schleife verlassen
                Exit For
            Else
                Terminvorhanden = False
            End If
        End If
    Next
End With
End Sub

Public Sub Terminefllen()
On Error GoTo Fehlerbehandlung
Call Freeze
With FrmTermine
    With .MSFlexGridTermine
        '.Height = 4700
        '.Width = 4250
        .Rows = 1
        .Cols = 5
        .ColWidth(eTermin.GridTerminNr) = 700
        .ColWidth(eTermin.GridTerminDatum) = 1000
        .ColWidth(eTermin.GridTerminUhrzeit) = 800
        .ColWidth(eTermin.GridTerminArt) = 2000
        .ColWidth(eTermin.GridTerminBeschreibung) = 4200
    
        .TextMatrix(0, eTermin.GridTerminNr) = "lfd. Nr.:"
        .TextMatrix(0, eTermin.GridTerminDatum) = "Datum:"
        .TextMatrix(0, eTermin.GridTerminUhrzeit) = "Uhrzeit:"
        .TextMatrix(0, eTermin.GridTerminArt) = "Termin - Art:"
        .TextMatrix(0, eTermin.GridTerminBeschreibung) = "Termin - Beschreibung:"
            
            If IsFilePath(Laufwerk & "Termine.db") Then
                'Datei extistiert ...
                'Daten aus Datei einlesen:
                LoadGridData FrmTermine.MSFlexGridTermine, _
                Laufwerk & "Termine.db", m_strStep
            End If
    
    End With
End With
Call Defrost
Exit Sub
Fehlerbehandlung:
Call Defrost
MsgBox Err.Description, vbCritical, App.EXEName
End Sub

Public Sub Terminespeichern()
On Error GoTo Abbruch

Dim Buchstabe As String
'Eingabe\FSO-Drives.frm
Dim fso As New FileSystemObject
Dim dr As Drive
Dim drLaufwerk As String

        
    Screen.MousePointer = vbHourglass
'das aktuelle Verzeichnis wird nun im mdlffentlicheVariablen gespeichert
'fr dr (Laufwerk) sind die ersten 2 Zeichen wichtig und mssen ermittelt werden
Buchstabe = Left(Laufwerk, 2)

'bei nicht betriebsbereitem Laufwerk
On Error Resume Next

For Each dr In fso.Drives
    'Laufwerksbuchstaben einsetzen
    'den Laufwerkstyp ermitteln
    If dr = Buchstabe Then
        Select Case dr.DriveType
            Case Is = CDRom
                drLaufwerk = "CD-Rom"
            Case Is = Fixed
                drLaufwerk = "Festplatte"
            Case Is = RamDisk
                drLaufwerk = "Ram-Disk"
            Case Is = Remote
                drLaufwerk = "Netzlaufwerk"
            Case Is = Removable
                drLaufwerk = "Wechseldatentrger"
            Case Else
                drLaufwerk = "Unbekannt"
        End Select
    'wenn gefunden Schleife verlassen
    Exit For
    End If
Next
Screen.MousePointer = vbDefault
        'drLaufwerk, der Laufwerkstyp ist nun ermittelt _
        und wird nun im mdlffentlicheVariablen gespeichert
    If dr.DriveType <> CDRom Then

        SaveGridData FrmTermine.MSFlexGridTermine, _
        Laufwerk & "Termine.db", m_strStep
        Termindatengendert = False
    End If
    
    Set fso = Nothing
    Set dr = Nothing

Exit Sub
Abbruch:
    
    If Err.number <> 32755 Then
        Call Fehlermeldung
    End If
    
    Set fso = Nothing
    Set dr = Nothing

End Sub

Public Sub Termineinfgen(ByVal Termindatum As Date, ByVal Terminuhrzeit As Date)
With FrmTermine
Dim strTag As String

    strTag = strFeiertag(Year(Termindatum), Termindatum)
    
    If DatumamFeiertag = True Then
        If MsgBox("dein Termin am " & .lblTerminDatum.Caption _
        & " ist an einem Feiertag !" & Chr(13) & "Feiertagname : " _
        & strTag & Chr(13) & Chr(13) _
        & "Soll der Termin trotzdem angenommen werden ?", _
        vbQuestion + vbYesNo + vbDefaultButton1, _
        "Termin an einem Feiertag") = vbYes Then
        
            Call TerminaufVorhandenseinprfen(Termindatum, Terminuhrzeit)
            If Terminvorhanden = False Then
                With .MSFlexGridTermine
                    .Rows = .Rows + 1
                    .TextMatrix(.Rows - 1, eTermin.GridTerminNr) = .Rows - 1
                    .TextMatrix(.Rows - 1, eTermin.GridTerminDatum) = Format(Termindatum, "dd.mm.yyyy")
                    .TextMatrix(.Rows - 1, eTermin.GridTerminUhrzeit) = Format(Terminuhrzeit, "hh:mm")
                    .TextMatrix(.Rows - 1, eTermin.GridTerminArt) = Trim(FrmTermine.cboTerminart.Text)
                    .TextMatrix(.Rows - 1, eTermin.GridTerminBeschreibung) = Trim(FrmTermine.txtTerminBeschreibung.Text)
                    Termindatengendert = True
                End With
            Else
                With .MSFlexGridTermine
                    Call PlayFrageSound
                    If MsgBox("ein Termin besteht bereits am:" _
                    & Chr(13) & Chr(13) & "Datum : " _
                    & .TextMatrix(.Row, eTermin.GridTerminDatum) _
                    & Chr(13) & Chr(13) & "Uhrzeit : " & .TextMatrix(.Row, eTermin.GridTerminUhrzeit) & Chr(13) _
                    & Chr(13) & "Termin - Art : " & .TextMatrix(.Row, eTermin.GridTerminArt) & Chr(13) _
                    & Chr(13) & "Termin - Beschreibung : " & .TextMatrix(.Row, eTermin.GridTerminBeschreibung) & Chr(13) _
                    & Chr(13) & Chr(13) & "Soll er trotzdem bernommen werden ?", _
                    vbQuestion + vbYesNo + vbDefaultButton2, _
                    "Termin ist bereits vergeben") = vbYes Then
                        Call PlayAnnehmenSound
                        .Rows = .Rows + 1
                        .TextMatrix(.Rows - 1, eTermin.GridTerminNr) = .Rows - 1
                        .TextMatrix(.Rows - 1, eTermin.GridTerminDatum) = Format(Termindatum, "dd.mm.yyyy")
                        .TextMatrix(.Rows - 1, eTermin.GridTerminUhrzeit) = Format(Terminuhrzeit, "hh:mm")
                        .TextMatrix(.Rows - 1, eTermin.GridTerminArt) = Trim(FrmTermine.cboTerminart.Text)
                        .TextMatrix(.Rows - 1, eTermin.GridTerminBeschreibung) = Trim(FrmTermine.txtTerminBeschreibung.Text)
                        Termindatengendert = True
                    Else
                        Call PlayAblehnenSound
                    End If
                End With
            End If
        Else
            Call PlayAblehnenSound
        End If
        
    Else
    
        Call TerminaufVorhandenseinprfen(Termindatum, Terminuhrzeit)
        If Terminvorhanden = False Then
            With .MSFlexGridTermine
                .Rows = .Rows + 1
                .TextMatrix(.Rows - 1, eTermin.GridTerminNr) = .Rows - 1
                .TextMatrix(.Rows - 1, eTermin.GridTerminDatum) = Format(Termindatum, "dd.mm.yyyy")
                .TextMatrix(.Rows - 1, eTermin.GridTerminUhrzeit) = Format(Terminuhrzeit, "hh:mm")
                .TextMatrix(.Rows - 1, eTermin.GridTerminArt) = Trim(FrmTermine.cboTerminart.Text)
                .TextMatrix(.Rows - 1, eTermin.GridTerminBeschreibung) = Trim(FrmTermine.txtTerminBeschreibung.Text)
                Termindatengendert = True
            End With
        Else
            With .MSFlexGridTermine
                Call PlayFrageSound
                If MsgBox("ein Termin besteht bereits am:" _
                & Chr(13) & Chr(13) & "Datum : " _
                & .TextMatrix(.Row, eTermin.GridTerminDatum) _
                & Chr(13) & Chr(13) & "Uhrzeit : " & .TextMatrix(.Row, eTermin.GridTerminUhrzeit) & Chr(13) _
                & Chr(13) & "Termin - Art : " & .TextMatrix(.Row, eTermin.GridTerminArt) & Chr(13) _
                & Chr(13) & "Termin - Beschreibung : " & .TextMatrix(.Row, eTermin.GridTerminBeschreibung) & Chr(13) _
                & Chr(13) & Chr(13) & "Soll er trotzdem bernommen werden ?", _
                vbQuestion + vbYesNo + vbDefaultButton2, _
                "Termin ist bereits vergeben") = vbYes Then
                    Call PlayAnnehmenSound
                    .Rows = .Rows + 1
                    .TextMatrix(.Rows - 1, eTermin.GridTerminNr) = .Rows - 1
                    .TextMatrix(.Rows - 1, eTermin.GridTerminDatum) = Format(Termindatum, "dd.mm.yyyy")
                    .TextMatrix(.Rows - 1, eTermin.GridTerminUhrzeit) = Format(Terminuhrzeit, "hh:mm")
                    .TextMatrix(.Rows - 1, eTermin.GridTerminArt) = Trim(FrmTermine.cboTerminart.Text)
                    .TextMatrix(.Rows - 1, eTermin.GridTerminBeschreibung) = Trim(FrmTermine.txtTerminBeschreibung.Text)
                    Termindatengendert = True
                Else
                    Call PlayAblehnenSound
                End If
            End With
        End If
    End If
End With
End Sub

Public Sub Serientermineeinfgen()
Dim i As Long

With FrmTermine
Dim WochentagIndex As Integer
Dim strTag As String

    With .MSFlexGridTermine
        Seriendatum = FrmTermine.lblTerminDatum.Caption
        SerienUhrzeit = FrmTermine.lblTerminUhrzeit.Caption
        
        For i = 1 To FrmTermine.cboSerienTermin.ListIndex * 7
    
            'die Wochentage durchlaufen
            For WochentagIndex = 0 To 6
                'auf entsprechenden Wochentag prfen
                If Format(Seriendatum, "dddd") = FrmTermine.chkWochentag(WochentagIndex).Caption Then
                
                    'prfen auf als Ausnahme aktiviert oder nicht
                    If FrmTermine.chkWochentag(WochentagIndex).Value = 0 Then
                    
                    'auf einen Feriertag hin vergleichen
                    strTag = strFeiertag(Year(Seriendatum), Seriendatum)
                    
                        If DatumamFeiertag = True Then
                            Call PlayFrageSound
                            'wenn an einem Feiertag dann nachfragen
                            If MsgBox("dein Termin am " & Seriendatum _
                            & " ist an einem Feiertag !" & Chr(13) & "Feiertagname : " _
                            & strTag & Chr(13) & Chr(13) _
                            & "Soll der Termin trotzdem angenommen werden ?", _
                            vbQuestion + vbYesNo + vbDefaultButton1, _
                            "Termin an einem Feiertag") = vbYes Then
                            
                            'prfen ob bereits ein Termin besteht
                            Call TerminaufVorhandenseinprfen(Seriendatum, FrmTermine.lblTerminUhrzeit.Caption)
                            
                                If Terminvorhanden = False Then
                                    .Rows = .Rows + 1
                                    r = .Rows - 1
                                    .TextMatrix(r, eTermin.GridTerminNr) = .Rows - 1
                                    .TextMatrix(r, eTermin.GridTerminDatum) = Format(Seriendatum, "dd.mm.yyyy")
                                    .TextMatrix(r, eTermin.GridTerminUhrzeit) = FrmTermine.lblTerminUhrzeit.Caption
                                    .TextMatrix(r, eTermin.GridTerminArt) = Trim(FrmTermine.cboTerminart.Text)
                                    .TextMatrix(r, eTermin.GridTerminBeschreibung) = Trim(FrmTermine.txtTerminBeschreibung.Text)
                                    Termindatengendert = True
                                Else
                                    Call PlayFrageSound
                                    If MsgBox("ein Termin besteht bereits am:" _
                                    & Chr(13) & Chr(13) & "Datum : " _
                                    & .TextMatrix(i, eTermin.GridTerminDatum) _
                                    & Chr(13) & Chr(13) & "Uhrzeit : " & .TextMatrix(i, eTermin.GridTerminUhrzeit) & Chr(13) _
                                    & Chr(13) & "Termin - Art : " & .TextMatrix(i, eTermin.GridTerminArt) & Chr(13) _
                                    & Chr(13) & "Termin - Beschreibung : " & .TextMatrix(i, eTermin.GridTerminBeschreibung) & Chr(13) _
                                    & Chr(13) & Chr(13) & "Soll er trotzdem bernommen werden ?", _
                                    vbQuestion + vbYesNo + vbDefaultButton2, _
                                    "Termin ist bereits vergeben") = vbYes Then
                                        Call PlayAnnehmenSound
                                        .Rows = .Rows + 1
                                        r = .Rows - 1
                                        .TextMatrix(.Rows - 1, eTermin.GridTerminNr) = .Rows - 1
                                        .TextMatrix(.Rows - 1, eTermin.GridTerminDatum) = Format(Seriendatum, "dd.mm.yyyy")
                                        .TextMatrix(.Rows - 1, eTermin.GridTerminUhrzeit) = FrmTermine.lblTerminUhrzeit.Caption
                                        .TextMatrix(.Rows - 1, eTermin.GridTerminArt) = Trim(FrmTermine.cboTerminart.Text)
                                        .TextMatrix(.Rows - 1, eTermin.GridTerminBeschreibung) = Trim(FrmTermine.txtTerminBeschreibung.Text)
                                        Termindatengendert = True
                                    Else
                                        Call PlayAblehnenSound
                                    End If
                                End If
                            Else
                                Call PlayAblehnenSound
                            End If
                        
                        Else
                            
                            'wenn nicht an einem Feiertag
                            Call TerminaufVorhandenseinprfen(Seriendatum, FrmTermine.lblTerminUhrzeit.Caption)
                            If Terminvorhanden = False Then
                                .Rows = .Rows + 1
                                r = .Rows - 1
                                .TextMatrix(r, eTermin.GridTerminNr) = .Rows - 1
                                .TextMatrix(r, eTermin.GridTerminDatum) = Format(Seriendatum, "dd.mm.yyyy")
                                .TextMatrix(r, eTermin.GridTerminUhrzeit) = FrmTermine.lblTerminUhrzeit.Caption
                                .TextMatrix(r, eTermin.GridTerminArt) = Trim(FrmTermine.cboTerminart.Text)
                                .TextMatrix(r, eTermin.GridTerminBeschreibung) = Trim(FrmTermine.txtTerminBeschreibung.Text)
                                Termindatengendert = True
                            Else
                                Call PlayFrageSound
                                If MsgBox("ein Termin besteht bereits am:" _
                                & Chr(13) & Chr(13) & "Datum : " _
                                & .TextMatrix(i, eTermin.GridTerminDatum) _
                                & Chr(13) & Chr(13) & "Uhrzeit : " & .TextMatrix(i, eTermin.GridTerminUhrzeit) & Chr(13) _
                                & Chr(13) & "Termin - Art : " & .TextMatrix(i, eTermin.GridTerminArt) & Chr(13) _
                                & Chr(13) & "Termin - Beschreibung : " & .TextMatrix(i, eTermin.GridTerminBeschreibung) & Chr(13) _
                                & Chr(13) & Chr(13) & "Soll er trotzdem bernommen werden ?", _
                                vbQuestion + vbYesNo + vbDefaultButton2, _
                                "Termin ist bereits vergeben") = vbYes Then
                                    Call PlayAnnehmenSound
                                    .Rows = .Rows + 1
                                    r = .Rows - 1
                                    .TextMatrix(.Rows - 1, eTermin.GridTerminNr) = .Rows - 1
                                    .TextMatrix(.Rows - 1, eTermin.GridTerminDatum) = Format(Seriendatum, "dd.mm.yyyy")
                                    .TextMatrix(.Rows - 1, eTermin.GridTerminUhrzeit) = FrmTermine.lblTerminUhrzeit.Caption
                                    .TextMatrix(.Rows - 1, eTermin.GridTerminArt) = Trim(FrmTermine.cboTerminart.Text)
                                    .TextMatrix(.Rows - 1, eTermin.GridTerminBeschreibung) = Trim(FrmTermine.txtTerminBeschreibung.Text)
                                    Termindatengendert = True
                                Else
                                    Call PlayAblehnenSound
                                End If
                            End If
                        
                        End If
                    End If  'Ende von: auf als Ausnahme prfen
                End If  'Ende von: auf Wochentag prfen
            Next
            Seriendatum = DateAdd("d", 1, Seriendatum)
        Next
    End With
End With
End Sub

Public Sub Terminlschen()
On Error GoTo Fehlerbehandlung
With FrmTermine.MSFlexGridTermine
    
If .Rows > 1 Then
    If .Row >= 1 Then
        Call PlayFrageSound
        If MsgBox("soll der Termin :" & Chr(13) & Chr(13) & "Datum : " _
        & .TextMatrix(.Row, eTermin.GridTerminDatum) _
        & Chr(13) & Chr(13) & "Uhrzeit : " & .TextMatrix(.Row, eTermin.GridTerminUhrzeit) & Chr(13) _
        & Chr(13) & "Termin - Art : " & .TextMatrix(.Row, eTermin.GridTerminArt) & Chr(13) _
        & Chr(13) & "Termin - Beschreibung : " & .TextMatrix(.Row, eTermin.GridTerminBeschreibung) & Chr(13) _
        & Chr(13) & "gelscht werden ?", _
        vbQuestion + vbDefaultButton1 + vbYesNo, "Termin lschen") = vbYes Then
            
            Call PlayLschSound
            If .Rows > 2 Then
                .RemoveItem .Row
            Else
                .Clear
                '.Height = 4700
                '.Width = 4250
                .Rows = 1
                .Cols = 5
                .ColWidth(eTermin.GridTerminNr) = 700
                .ColWidth(eTermin.GridTerminDatum) = 1000
                .ColWidth(eTermin.GridTerminUhrzeit) = 800
                .ColWidth(eTermin.GridTerminArt) = 2000
                .ColWidth(eTermin.GridTerminBeschreibung) = 4200
            
                .TextMatrix(0, eTermin.GridTerminNr) = "lfd. Nr.:"
                .TextMatrix(0, eTermin.GridTerminDatum) = "Datum:"
                .TextMatrix(0, eTermin.GridTerminUhrzeit) = "Uhrzeit:"
                .TextMatrix(0, eTermin.GridTerminArt) = "Termin - Art:"
                .TextMatrix(0, eTermin.GridTerminBeschreibung) = "Termin - Beschreibung:"
                FrmTermine.cboTerminart.Text = ""
                FrmTermine.txtTerminBeschreibung.Text = ""
            End If
            Termindatengendert = True
        Else
            Call PlayAblehnenSound
        End If
    Else
        Call PlayHinweisSound
        MsgBox "Du hast noch keinen Termin zum Lschen gewhlt!", vbExclamation, "bitte Lsch-Termin whlen"
        Call PlayClickSound
    End If
Else
    Call PlayHinweisSound
    MsgBox "Es ist kein Termin zum Lschen vorhanden !", vbExclamation, "Termine"
    Call PlayClickSound
End If

End With
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub Terminndern()
Dim Termindatum As Date
On Error GoTo Fehlerbehandlung
With FrmTermine.MSFlexGridTermine
If .Rows > 1 Then
    If .Row > 0 Then
        
        Call PlayFrageSound
        If MsgBox("soll der Termin :" & Chr(13) & Chr(13) & "Datum : " _
        & .TextMatrix(.Row, eTermin.GridTerminDatum) _
        & Chr(13) & Chr(13) & "Uhrzeit : " & .TextMatrix(.Row, eTermin.GridTerminUhrzeit) & Chr(13) _
        & Chr(13) & "Termin - Art : " & .TextMatrix(.Row, eTermin.GridTerminArt) & Chr(13) _
        & Chr(13) & "Termin - Beschreibung : " & .TextMatrix(.Row, eTermin.GridTerminBeschreibung) & Chr(13) _
        & Chr(13) & "gendert werden ?", _
        vbQuestion + vbDefaultButton1 + vbYesNo, "Termin ndern") = vbYes Then
            
            Call PlayAnnehmenSound
            Termindatum = .TextMatrix(.Row, eTermin.GridTerminDatum)
            FrmTermine.UpDownDatum.Value = CLng(Termindatum)
            Minute = Right(.TextMatrix(.Row, eTermin.GridTerminUhrzeit), 2)
            Stunde = Left(.TextMatrix(.Row, eTermin.GridTerminUhrzeit), 2)
            FrmTermine.UpDownMinute.Value = Minute
            FrmTermine.UpDownStunde.Value = Stunde
            FrmTermine.cboTerminart.Text = .TextMatrix(.Row, eTermin.GridTerminArt)
            FrmTermine.txtTerminBeschreibung.Text = .TextMatrix(.Row, eTermin.GridTerminBeschreibung)
            
            FrmTermine.cmdbernehmen.Caption = "ndern"
        Else
            Call PlayAblehnenSound
            FrmTermine.cmdbernehmen.Caption = "bernehmen"
        End If
            Call TerminDatumUhrzeitprfen(FrmTermine.lblTerminDatum.Caption, FrmTermine.lblTerminUhrzeit.Caption & ":00")
    End If

Else
    Call PlayHinweisSound
    MsgBox "Es ist kein Termin zum ndern vorhanden !", vbExclamation, "kein Termin"
    Call PlayClickSound
End If

End With
Exit Sub
Fehlerbehandlung:
MsgBox Err.Description, vbCritical, App.EXEName
End Sub

'******************************************************************************

'-------------------------------------------------------------------
'MSHFlexGrid - Daten aus Textdatei einlesen und speichern
'-------------------------------------------------------------------

Public Sub aufaktuelleTermineprfen(vstrFile As String, ByVal vstrSep As String)

On Error GoTo Fehlerbehandlung

'Daten aus Textdatei einlesen...

    Dim Fn As Integer
    Dim i As Long
    Dim astrData As Variant      'Datenfeld
    Dim intCols As Integer        'Datenfeldgre
    Dim bTerminvorhanden As Boolean
    Dim strTemp As String
    bTerminvorhanden = False
    
    Fn = FreeFile()
'Datei zum Lesen ffnen...
    Open vstrFile For Input As #Fn
      
        'Textdatei zeilenweise einlesen...
          Do While Not EOF(Fn)
            Line Input #Fn, strTemp
    
            If Len(strTemp) <> 0 Then
              'Zeile in einzelne Spalten zerlegen:
                astrData = Split(strTemp, vstrSep)
              'Datenfeldgre ermitteln:
                intCols = UBound(astrData)
                
              'Spaltenweise Daten einlesen und vergleichen
                For i = 0 To intCols
                    If IsDate(astrData(i)) Then
                        If Format(astrData(i), "dd.mm.yyyy") = Format(Date, "dd.mm.yyyy") Then
                            bTerminvorhanden = True
                        End If
                    End If
                Next i
            
            End If
          Loop
  
  'Datei schlieen:
    Close #Fn
    
    If bTerminvorhanden Then
        FrmTerminplaner.Show
    End If
Exit Sub
Fehlerbehandlung:
MsgBox "Fehler beim Laden der Datei!", vbExclamation, FrmTermine.Caption
End Sub

'******************************************************************************

'-------------------------------------------------------------------
'MSHFlexGrid - Daten aus Textdatei einlesen und speichern
'-------------------------------------------------------------------

Public Sub LoadGridData(ByVal vGrid As MSFlexGrid, ByVal _
             vstrFile As String, ByVal vstrSep As String, _
             Optional ByVal nFixedCols As Long = 1, _
             Optional ByVal nFixedRows As Long = 1)

On Error GoTo Fehlerbehandlung

'Daten aus Textdatei einlesen...

    Dim Fn As Integer
  
    Dim astrData As Variant      'Datenfeld
    Dim intCols As Integer        'Datenfeldgre
  
    Dim strTemp As String
  
    Dim r As Long                 'Zeile
    Dim c As Long                 'Spalte

    Fn = FreeFile()
'Datei zum Lesen ffnen...
    Open vstrFile For Input As #Fn
      
      With vGrid
        'Das Neuzeichnen des Grids nach jeder nderung unterbinden:
        '  (Bildschirmflackern vermeiden !!!)
          .Redraw = False
        
        'Zeilen-/Spaltenanzahl im Grid zurcksetzen:
          .Rows = 1
        'Textdatei zeilenweise einlesen...
          Do While Not EOF(Fn)
            Line Input #Fn, strTemp
    
            If Len(strTemp) <> 0 Then
              'Zeile in einzelne Spalten zerlegen:
                astrData = Split(strTemp, vstrSep)
              'Datenfeldgre ermitteln:
                intCols = UBound(astrData)
                
'                MsgBox intCols, vbInformation, "intCols"
                
              'Anzahl der Spalten im Grid  anpassen:
                If intCols + 1 > .Cols Then
                  .Cols = intCols + 1
                End If
                
              'Zeilenanzahl in Grid erhhen:
                .Rows = .Rows + 1
              'Zeile fr nchsten Eintrag festlegen:
                r = .Rows - 1
                
              'Spaltenweise Daten hinzufgen:
                For c = 0 To intCols
                    .TextMatrix(r, c) = astrData(c)
                Next c
            
            Else    'If Len(strTemp) <> 0
            
              'Zeilenanzahl in Grid erhhen:
                .Rows = .Rows + 1
            End If
          Loop
  
        'Grid neu zeichnen:
          .Redraw = True
      End With
  
  'Datei schlieen:
    Close #Fn

Termindatengendert = False

Exit Sub
Fehlerbehandlung:
Termindatengendert = False
DoEvents
MsgBox "Fehler beim Laden der Datei!", vbExclamation, FrmTermine.Caption
End Sub

Public Sub SaveGridData(ByVal vGrid As MSFlexGrid, ByVal _
               vstrFile As String, ByVal vstrSep As String)

On Error GoTo Fehlerbehandlung

'Daten in Textdatei speichern...
    Dim Fn As Integer
    
    Dim nRows As Long    'Anzahl Zeilen
    Dim nCols As Long    'Anzahl Spalten
    
    Dim strTemp As String
    
    Dim r As Long             'Zeile
    Dim c As Long             'Spalte
    
    With vGrid
        nRows = .Rows - 1    'Anzahl Zeilen im Grid
        nCols = .Cols - 1    'Anzahl Spalten im Grid
      
        Fn = FreeFile()
    
      'Datei zum Schreiben ffnen...
        Open vstrFile For Output As #Fn
          'Zeilenweise Spalten lesen und mit Trennzeichen verbinden ...
            For r = 1 To nRows
                strTemp = vbNullString
                For c = 0 To nCols - 1
                    strTemp = strTemp & (.TextMatrix(r, c) & vstrSep)
                Next c
              'Letzte Spalte noch aufnehmen:
                strTemp = strTemp & .TextMatrix(r, c)
              
              '-> Textdatei
                Print #Fn, strTemp
            Next r
      'Datei schlieen:
        Close #Fn
    End With

'Dim Msg As String
'Msg = "Datei wurde erfolgreich gespeichert"
'
'MsgBox Msg, vbInformation, FrmTermine.Caption
   
Exit Sub
Fehlerbehandlung:
DoEvents
MsgBox "Fehler beim Speichern der Datei!", vbExclamation, FrmTermine.Caption
End Sub

Public Sub LoadTerminData(ByVal vGrid As MSFlexGrid, ByVal _
             vstrFile As String, ByVal vstrSep As String, ByVal datum As Date, _
             Optional ByVal nFixedCols As Long = 1, _
             Optional ByVal nFixedRows As Long = 1)

On Error GoTo Fehlerbehandlung

'Daten aus Textdatei einlesen...

    Dim Fn As Integer
  
    Dim astrData As Variant      'Datenfeld
    Dim intCols As Integer        'Datenfeldgre
  
    Dim strTemp As String
  
    Dim r As Long                 'Zeile
    Dim c As Long                 'Spalte

    Fn = FreeFile()
'Datei zum Lesen ffnen...
    Open vstrFile For Input As #Fn
      
      With vGrid
        'Das Neuzeichnen des Grids nach jeder nderung unterbinden:
        '  (Bildschirmflackern vermeiden !!!)
          .Redraw = False
        
        'Zeilen-/Spaltenanzahl im Grid zurcksetzen:
          .Rows = 1
        'Textdatei zeilenweise einlesen...
          Do While Not EOF(Fn)
            Line Input #Fn, strTemp
    
            If Len(strTemp) <> 0 Then
                '
                If IsDate(Mid(strTemp, 3, 10)) Then
                    Dim Vergleichsdatum As Date
                    Vergleichsdatum = Mid(strTemp, 3, 10)
                    
                    If Format(Vergleichsdatum, "dd.mm.yyyy") = Format(datum, "dd.mm.yyyy") Then
                    
                      'Zeile in einzelne Spalten zerlegen:
                        astrData = Split(strTemp, vstrSep)
                      'Datenfeldgre ermitteln:
                        intCols = UBound(astrData)
                        
        '                MsgBox intCols, vbInformation, "intCols"
                        
                      'Anzahl der Spalten im Grid  anpassen:
                        If intCols + 1 > .Cols Then
                          .Cols = intCols + 1
                        End If
                        
                      'Zeilenanzahl in Grid erhhen:
                        .Rows = .Rows + 1
                      'Zeile fr nchsten Eintrag festlegen:
                        r = .Rows - 1
                        
                      'Spaltenweise Daten hinzufgen:
                        For c = 0 To intCols
                            If c = 0 Then
                                .TextMatrix(r, c) = r
                            Else
                                .TextMatrix(r, c) = astrData(c)
                            End If
                        Next c
                    End If
                ElseIf IsDate(Mid(strTemp, 4, 10)) Then
                    Vergleichsdatum = Mid(strTemp, 4, 10)
                    
                    If Format(Vergleichsdatum, "dd.mm.yyyy") = Format(datum, "dd.mm.yyyy") Then
                    
                      'Zeile in einzelne Spalten zerlegen:
                        astrData = Split(strTemp, vstrSep)
                      'Datenfeldgre ermitteln:
                        intCols = UBound(astrData)
                        
        '                MsgBox intCols, vbInformation, "intCols"
                        
                      'Anzahl der Spalten im Grid  anpassen:
                        If intCols + 1 > .Cols Then
                          .Cols = intCols + 1
                        End If
                        
                      'Zeilenanzahl in Grid erhhen:
                        .Rows = .Rows + 1
                      'Zeile fr nchsten Eintrag festlegen:
                        r = .Rows - 1
                        
                      'Spaltenweise Daten hinzufgen:
                        For c = 0 To intCols
                            If c = 0 Then
                                .TextMatrix(r, c) = r
                            Else
                                .TextMatrix(r, c) = astrData(c)
                            End If
                        Next c
                    End If
                ElseIf IsDate(Mid(strTemp, 5, 10)) Then
                    Vergleichsdatum = Mid(strTemp, 5, 10)
                    
                    If Format(Vergleichsdatum, "dd.mm.yyyy") = Format(datum, "dd.mm.yyyy") Then
                    
                      'Zeile in einzelne Spalten zerlegen:
                        astrData = Split(strTemp, vstrSep)
                      'Datenfeldgre ermitteln:
                        intCols = UBound(astrData)
                        
        '                MsgBox intCols, vbInformation, "intCols"
                        
                      'Anzahl der Spalten im Grid  anpassen:
                        If intCols + 1 > .Cols Then
                          .Cols = intCols + 1
                        End If
                        
                      'Zeilenanzahl in Grid erhhen:
                        .Rows = .Rows + 1
                      'Zeile fr nchsten Eintrag festlegen:
                        r = .Rows - 1
                        
                      'Spaltenweise Daten hinzufgen:
                        For c = 0 To intCols
                            If c = 0 Then
                                .TextMatrix(r, c) = r
                            Else
                                .TextMatrix(r, c) = astrData(c)
                            End If
                        Next c
                    End If
                End If
            Else    'If Len(strTemp) <> 0
            
              'Zeilenanzahl in Grid erhhen:
                .Rows = .Rows + 1
            End If
          Loop
  
        'Grid neu zeichnen:
          .Redraw = True
      End With
  
  'Datei schlieen:
    Close #Fn

Termindatengendert = False

Exit Sub
Fehlerbehandlung:
Termindatengendert = False
DoEvents
MsgBox "Fehler beim Laden der Datei!", vbExclamation, FrmTermine.Caption
End Sub
